﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Globalization;

namespace RodokmenDiplomka.Data
{
    [Serializable]
    public class Datum : IGedZaznam
    {
        private const string DEFAULTFORMAT = "dd.MM. yyyy";
        enum previx { non, ABT };
        enum typUdaje { non, from, to , fromTo };

        DateTime dat;
        DateTime datumTo;
        String vlastniFormat = DEFAULTFORMAT;
        String vlastniFormatTO = DEFAULTFORMAT;
        typUdaje typ = typUdaje.non;

        public DateTime Dat
        {
            get { return dat; }
            set { dat = value; }
        }

        public DateTime DatTo
        {
            get { return datumTo; }
            set { datumTo = value; }
        }
        previx predvolba = previx.non;

        private previx Predvolba
        {
            get { return predvolba; }
            set { predvolba = value; }
        }
        previx predvolbaTo = previx.non;

        private previx PredvolbaTo
        {
            get { return predvolbaTo; }
            set { predvolbaTo = value; }
        }

        public void ZatridToken(GedToken t)
        {
            setDatum(t.Pole);

        }

        public void Exportovat(System.IO.StreamWriter sw)
        {
            sw.Write("DATE ");
            if (predvolba == previx.ABT)
            {
                sw.Write("ABT ");
            }
            if (!vlastniFormat.Equals(DEFAULTFORMAT))
            {
                sw.Write(Dat.ToString(vlastniFormat, CultureInfo.CreateSpecificCulture("en-US")));
            }
            else
            {
                sw.Write(Dat.ToString("dd MMM yyy", CultureInfo.CreateSpecificCulture("en-US")));
            }
            sw.WriteLine();
        }

        public void setDatum(String pole)
        {
            String pom = "";
            if (Regex.IsMatch(pole, "^ABT"))
            {
                Predvolba = previx.ABT;
                pom = pole.Substring(3);
            }
            else
            {
                pom = pole;
            }

            if (pom.Trim().Length <= 4 && pom.Trim().Length>2)
            {
                //Predvolba = previx.ABT;//asi se nemusi davat vždy
                pom = "01/01/" + pom;
                vlastniFormat = "yyy";
            }
            try
            {
                if (!String.IsNullOrWhiteSpace(pom))
                {
                    DateTime dt = Convert.ToDateTime(pom);
                    Dat = dt;
                }
                else
                {
                    Dat = new DateTime();
                }
            }
            catch (Exception) {
                Dat = new DateTime();
            }
            
        }

        public String getDatum()
        {
            if (dat == DateTime.MinValue)
            {
                return "";
            }
            else if (DatTo != DateTime.MinValue) {//typUdaje.from
                return "FROM " + dat.ToString(vlastniFormat) + " TO " + datumTo.ToString(vlastniFormatTO);
            }
            if(typ != typUdaje.non){
                if (typ == typUdaje.from) {
                    return "FROM " + dat.ToString(vlastniFormat);
                }
                else if (typ == typUdaje.to) {
                    return "TO " + dat.ToString(vlastniFormat);
                }
            }
            return dat.ToString(vlastniFormat);
        }

        public bool isPresne()
        {
            if (Predvolba == previx.non)
            {
                return true;
            }
            return false;
        }
        public void setPresne(bool presne)
        {
            if (presne)
            {
                Predvolba = previx.non;
            }
            else
            {
                Predvolba = previx.ABT;
            }
        }
        public string getRok()
        {
            if (dat == DateTime.MinValue)
            {
                return "";
            }
            return dat.ToString("yyyy");
        }
    }
}
