﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;

namespace RodokmenDiplomka
{
    [Serializable]
    public class Header:IGedZaznam
    {
        private String source;
        private String sourceName;
        private String sourceVersion;
        private String sourceCorporation;
        private String sourceWeb;
        private String Destination;
        private String date;
        private String file;
        private String characterEncoding;
        //private String gedc;
        private String gedcomVersion;
        private String gedcomForm;
        private String gedcomModifiedPerson;
        private bool isGedc = false;

        public Header() { 
        
        }

        public void ZatridToken(GedToken t)
        {
            switch (t.Typ)
            {
                case "SOUR":
                    source = t.Pole;
                    break;
                case "NAME":
                    sourceName = t.Pole;
                    break;
                case "VERS":
                    if (isGedc && string.IsNullOrEmpty(gedcomVersion))
                    {
                        gedcomVersion = t.Pole;
                    }
                    else {
                        sourceVersion = t.Pole;
                    }
                    break;
                case "CORP":
                    sourceCorporation = t.Pole;
                    break;
                case "WWW":
                    sourceWeb = t.Pole;
                    break;
                case "DEST":
                    Destination = t.Pole;
                    break;
                case "DATE":
                    date = t.Pole;
                    break;
                case "FILE":
                    file = t.Pole;
                    break;
                case "CHAR":
                    characterEncoding = t.Pole;
                    break;
                case "GEDC":
                    isGedc = true;
                    break;
                /*case "VERS":
                    break;*/
                case "FORM":
                    gedcomForm = t.Pole;
                    break;
                case "SUBM":
                    gedcomModifiedPerson = t.Pole;
                    break;   
                default:
                    throw new Exception("Chybné rozhodování hlavička");
            }
        }


        public void Exportovat(System.IO.StreamWriter sw)
        {
            sw.WriteLine("0 HEAD");
            sw.WriteLine("1 SOUR " + "Rodokmen diplomka");
            sw.WriteLine("2 NAME " + "Rodokmen diplomka");
            sw.WriteLine("2 VERS " + "1.0");
            sw.WriteLine("2 CORP " + "Hlaváček František UPCE FEI");
            sw.WriteLine("3 WWW " + "http://upce.cz");
            sw.WriteLine("1 DEST " + "Rodokmen diplomka");
            DateTime d = DateTime.Now;
            sw.WriteLine("1 DATE " + d.ToString("dd MMM yyyy", CultureInfo.CreateSpecificCulture("en-US")));
            sw.WriteLine("1 FILE " + file);
            sw.WriteLine("1 CHAR " + sw.Encoding.WebName);
            sw.WriteLine("1 GEDC");
            sw.WriteLine("2 VERS 5.5");
            sw.WriteLine("2 FORM LINEAGE-LINKED");
            sw.WriteLine("1 SUBM " + gedcomModifiedPerson);
        }
    }
}
