﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RodokmenDiplomka
{
    [Serializable]
    public class ObjFile: IGedZaznam
    {

        public string Path { get; set; }
        public string Form { get; set; }
        public bool Prim { get; set; }
        public string Title { get; set; }
        public string Type { get; set; }
        public bool Nalezen { get; set; }
        public string Zdroj { get; set; }
        public string MistoVeZdroji { get; set; }
        public string Comment { get; set; }

        public ObjFile() 
        { 
        
        }
        public ObjFile(int typ)
        {
            if (typ == 0) {
                Type = "DOC";
            }
            else if (typ == 1)
            {
                Type = "PHOTO";
            }else if (typ == 2) { 
            
            }else{
                Type = "BOOK";
            }
        }
        public void ZatridToken(GedToken t)
        {
            switch (t.Typ)
            {
                case "OBJE":
                    break;
                case "FILE":
                    Path = t.Pole;
                    break;
                case "FORM":
                    Form = t.Pole;
                    break;
                case "_PRIM":
                    if ("Y".ToUpper().Equals(t.Pole.Trim().ToUpper()))
                    {
                        Prim = true;
                    }
                    else {
                        Prim = false;
                    }
                    //Prim = t.Pole;
                    break;
                case "TITL":
                    Title = t.Pole;
                    break;
                case "_TYPE":
                    Type = t.Pole;
                    break;
                default:
                    throw new Exception("Chybné rozhodování Obj file");
            }
        }

        public void Exportovat(System.IO.StreamWriter sw)
        {
            sw.WriteLine("1 OBJE");
            if (!String.IsNullOrEmpty(Path)) sw.WriteLine("2 FILE " + Path);
            if (!String.IsNullOrEmpty(Form)) sw.WriteLine("3 FORM " + Form);
            if (!String.IsNullOrEmpty(Title)) sw.WriteLine("2 TITL " + Title);
            if (Prim != null)
            {
                if (Prim)
                {
                    sw.WriteLine("2 _PRIM Y");
                }
                else
                {
                    sw.WriteLine("2 _PRIM N");
                }
            }
            else {
                sw.WriteLine("2 _PRIM N");
            }
            //if (!String.IsNullOrEmpty(Form) && !String.IsNullOrEmpty(Prim)) sw.WriteLine("2 _PRIM " + Prim);
            if (!String.IsNullOrEmpty(Type)) sw.WriteLine("2 _TYPE " + Type);
        }
    }
}
