﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RodokmenDiplomka.Data
{
    [Serializable]
    public class Place: IGedZaznam
    {
        string celyNazev = "";

        public Place()
        {
            this.celyNazev = "";
            vynulujSouradnice();
        }

        public Place(string nazev)
        {
            this.celyNazev = nazev;
            vynulujSouradnice();
        }

        public string CelyNazev
        {
            get { return celyNazev; }
            set { celyNazev = value; vynulujSouradnice(); }
        }

        private void vynulujSouradnice()
        {
            Longtitude = Double.MinValue;
            Latitude = Double.MinValue;
        }
        public double Latitude { get; set; }
        public double Longtitude { get; set; }

        public void ZatridToken(GedToken t)
        {
            CelyNazev = t.Pole;
            vynulujSouradnice();
        }

        public void Exportovat(System.IO.StreamWriter sw)
        {
            sw.Write("PLAC ");

            sw.Write(CelyNazev);
            sw.WriteLine();
        }
    }
}
