﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RodokmenDiplomka.Data;
using RodokmenDiplomka.Function;
using RodokmenDiplomka.Forms;
using System.IO;

namespace RodokmenDiplomka
{
    class SpravaRodokmenu
    {
        List<Rodokmen> rodokmeny = null;
        private int aktualniRodokmen = 1;
        private Individual aktualniOsoba = null;
        private List<Place> mista;
        private List<String> pricinyUmrti;
        private string cestaKRodokmenu = "";
        private string nazevRodokmenu = "";
        public SpravceHistorie SpravceHist { get; set; }

        public SpravaRodokmenu()
        {
            SpravceHist = null;
            SpravceHist = new SpravceHistorie();
            rodokmeny = new List<Rodokmen>();
            rodokmeny.Add(null);
            mista = new List<Place>();
            pricinyUmrti = new List<string>();
        }
        internal void ImportGed55(string pathFile)
        {
            Ged55Import gi = new Ged55Import();

            rodokmeny[aktualniRodokmen - 1] = gi.Read(pathFile);
            sparujPomocnePole();
            SpravceHist = null;
            SpravceHist = new SpravceHistorie();
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
        }

        private void sparujPomocnePole()
        {
            mista.Clear();
            pricinyUmrti.Clear();
            foreach (Individual os in rodokmeny[aktualniRodokmen - 1].getOsoby())
            {
                pridejMisto(mista, os.BirthPlace);
                pridejMisto(mista, os.DiedPlace);
                pridejMisto(mista, os.BuriPlace);
                pridejMisto(mista, os.ResiPlace);

                pridejPricinu(pricinyUmrti, os.DiedCause);
            }

            foreach (Family f in rodokmeny[aktualniRodokmen - 1].getRodiny())
            {
                pridejMisto(mista, f.MarriagePlace);
            }
        }

        private void pridejPricinu(List<string> pricinyUmrti, string pr)
        {
            bool nalezeno = false;
            foreach (String m in pricinyUmrti)
            {
                if (!string.IsNullOrEmpty(pr)
                        && pr.Equals(m))
                {
                    nalezeno = true;
                    break;
                }
            }
            if (!string.IsNullOrEmpty(pr)
                        && !nalezeno) pricinyUmrti.Add(pr);
        }

        private void pridejMisto(List<Place> mistaSeznam, string noveMisto)
        {
            bool nalezeno = false;
            foreach (Place m in mistaSeznam)
            {
                if (!string.IsNullOrEmpty(noveMisto)
                        && noveMisto.Equals(m.CelyNazev))
                {
                    nalezeno = true;
                    break;
                }
            }
            if (!string.IsNullOrEmpty(noveMisto)
                        && !nalezeno) mistaSeznam.Add(new Place(noveMisto));

        }

        internal void ExportGed55(string pathFile)
        {
            Ged55Export ge = new Ged55Export();
            ge.write(pathFile, rodokmeny[aktualniRodokmen - 1]);
        }

        internal List<System.Windows.Forms.ListViewItem> getOsobyListBoxItem(int p)
        {
            List<System.Windows.Forms.ListViewItem> seznam = new List<System.Windows.Forms.ListViewItem>();

            if (rodokmeny[aktualniRodokmen - 1] == null) return seznam;

            foreach (Individual os in rodokmeny[aktualniRodokmen - 1].getOsoby())
            {
                System.Windows.Forms.ListViewItem item = new System.Windows.Forms.ListViewItem(os.Id.ToString());
                item.SubItems.Add(os.dejCelePrijmeniJmeno());
                item.SubItems.Add(os.getRokNarozeni());
                item.Tag = os;
                seznam.Add(item);
            }
            return seznam;
        }

        internal void ZmenAktualniOsobu(int index)
        {
            aktualniOsoba = rodokmeny[aktualniRodokmen - 1].getOsoba(index);
        }

        internal void ZmenAktualniOsobu(Individual os)
        {
            if (os != null)
            {
                aktualniOsoba = os;
            }
            else
            {
                aktualniOsoba = null;
            }
        }

        internal Individual getAktualniOsoba()
        {
            return aktualniOsoba;
        }

        internal List<String> dejMista()
        {
            List<string> m = new List<string>();
            m.Add("");
            foreach (Place p in mista)
            {
                m.Add(p.CelyNazev);
            }
            m.Sort();
            return m;
        }
        internal List<Place> dejMistaPlace()
        {
            return mista;
        }

        internal List<Place> dejMistaPlaceVybraneOsoby()
        {
            List<Place> pom = new List<Place>();

            if (aktualniOsoba != null)
            {
                pridejMisto(pom, aktualniOsoba.BirthPlace);
                pridejMisto(pom, aktualniOsoba.DiedPlace);
                pridejMisto(pom, aktualniOsoba.BuriPlace);
                pridejMisto(pom, aktualniOsoba.ResiPlace);
            }
            return pom;
        }
        internal List<string> dejPricinyUmrti()
        {
            pricinyUmrti.Sort();
            pricinyUmrti.Insert(0, "");
            return pricinyUmrti;
        }

        internal Individual VytvorNovouOsobu()
        {
            Rodokmen r = rodokmeny[aktualniRodokmen - 1];
            if (r == null) return null;
            UlozVerziRodokmenu();
            aktualniOsoba = r.vytvorOsobu();
            return aktualniOsoba;
        }

        internal bool VytvorNovyRodokmen()
        {
            rodokmeny[aktualniRodokmen - 1] = new Rodokmen(null);
            SpravceHist = null;
            SpravceHist = new SpravceHistorie();
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            aktualniOsoba = null;
            return true;
        }

        internal bool VytvorNovyRodokmen(string cesta)
        {
            cestaKRodokmenu = cesta;

            rodokmeny[aktualniRodokmen - 1] = new Rodokmen(null);
            this.ExportAktualnihoRodokmenuDoBin(cestaKRodokmenu);
            SpravceHist = null;
            SpravceHist = new SpravceHistorie();
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            aktualniOsoba = null;
            return true;
        }

        internal bool VymazVybranouOsobu(Individual osoba)
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return false;

            if (osoba == null) return false;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            if (osoba.SpouseFamilyId != null)
            {
                while (osoba.SpouseFamilyId.Count > 0)
                {
                    Family f = osoba.SpouseFamilyId[0];
                    OdeberOsobuZRodiny(osoba, osoba.SpouseFamilyId[0]);
                    bool prazdna = true;
                    if (f.HusbandId != null && f.HusbandId.Id >= 0)
                    {
                        prazdna = false;
                    }
                    else if (f.WifeId != null && f.WifeId.Id >= 0)
                    {
                        prazdna = false;
                    }

                    if (prazdna)
                    {
                        OdeberRodinuZRodokmenu(f);
                    }
                }
                /*foreach (Family f in osoba.SpouseFamilyId)
                {
                    OdeberOsobuZRodiny(osoba, f);
                    bool prazdna = true;
                    if (f.HusbandId != null && f.HusbandId.Id >= 0)
                    {
                        prazdna = false;
                    }
                    else if (f.WifeId != null && f.WifeId.Id >= 0)
                    {
                        prazdna = false;
                    }

                    if (prazdna)
                    {
                        OdeberRodinuZRodokmenu(f);
                    }
                }*/
            }
            bool vysledek = rodokmeny[aktualniRodokmen - 1].VymazOsobu(osoba);

            if (osoba == aktualniOsoba && vysledek)
            {
                aktualniOsoba = null;
            }
            return vysledek;
        }

        internal bool UpravAktualniOsobu(Individual pom)
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return false;
            if (aktualniOsoba == null) return false;
            //SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            //prekopirovani poli asii
            if (rodokmeny[aktualniRodokmen - 1].UpdateOsoby(aktualniOsoba, pom))
            {
                sparujPomocnePole();
                return true;
            }

            return false;
        }

        internal bool ValidujDatum(string d)
        {
            Datum dat = new Datum();
            dat.setDatum(d);

            if (dat.Dat == DateTime.MinValue)
            {
                return false;
            }
            return true;
        }

        internal bool ExportAktualnihoRodokmenuDoBin(string p)
        {
            BinExportImport bEI = new BinExportImport();

            if (rodokmeny[aktualniRodokmen - 1] == null) return false;

            cestaKRodokmenu = p;
            bEI.Serializace<Rodokmen>(rodokmeny[aktualniRodokmen - 1], p);
            return true;
        }
        internal bool ExportAktualnihoRodokmenuDoBin()
        {
            if (String.IsNullOrWhiteSpace(cestaKRodokmenu)) return false;
            BinExportImport bEI = new BinExportImport();

            if (rodokmeny[aktualniRodokmen - 1] == null) return false;

            bEI.Serializace<Rodokmen>(rodokmeny[aktualniRodokmen - 1], cestaKRodokmenu);
            return true;
        }

        public bool ImportRodokmenuZBin(string p)
        {
            BinExportImport bEI = new BinExportImport();
            cestaKRodokmenu = p;

            rodokmeny[aktualniRodokmen - 1] = bEI.Deserializace<Rodokmen>(p);

            if (rodokmeny[aktualniRodokmen - 1] == null) return false;

            sparujPomocnePole();
            SpravceHist = null;
            SpravceHist = new SpravceHistorie();
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            return true;
        }

        internal List<Individual> DejOsoby()
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return new List<Individual>();
            return rodokmeny[aktualniRodokmen - 1].getOsoby().ToList();
        }

        internal Dictionary<int, Individual> DejOsobyDictionary()
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return new Dictionary<int, Individual>();

            return rodokmeny[aktualniRodokmen - 1].getOsobyDictionary();
        }

        internal bool IsAktualniRodokmen()
        {
            if (rodokmeny == null) return false;
            if (rodokmeny[aktualniRodokmen - 1] == null) return false;
            return true;
        }


        internal void UzavriAktualniRodokmen()
        {
            rodokmeny[aktualniRodokmen - 1] = null;
            cestaKRodokmenu = "";
            nazevRodokmenu = "";
            aktualniOsoba = null;
            mista = new List<Place>();
            pricinyUmrti = new List<string>();
            aktualniOsoba = null;
            SpravceHist = null;
            SpravceHist = new SpravceHistorie();
            //spravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
        }

        internal bool PridatOsobuDoRodinyJakoPartnera(Individual os, Family f)
        {
            Individual pom = null;
            if (os == null || f == null) return false;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            if (os.Sex != null && os.Sex.Equals("M"))
            {
                if (f.HusbandId == null)
                {
                    f.HusbandId = os;

                    os.SpouseFamilyId.Add(f);
                }
                else if (f.WifeId == null)
                {
                    f.WifeId = os;
                    os.SpouseFamilyId.Add(f);
                }
                else
                {
                    return false;
                }
            }
            else
            {
                if (f.WifeId == null)
                {
                    f.WifeId = os;
                    os.SpouseFamilyId.Add(f);
                }
                else if (f.HusbandId == null)
                {
                    f.HusbandId = os;
                    os.SpouseFamilyId.Add(f);
                }
                else
                {
                    return false;
                }
            }
            //this.UpravAktualniOsobu(os);
            return true;
        }

        internal bool ZmenRodinu(Family pomFam)
        {
            //jeste nevim co provest
            sparujPomocnePole();
            return true;
        }

        internal bool OdeberRodinuZRodokmenu(Family pomFam)
        {
            if (pomFam == null) return false;
            //SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            if (pomFam.Children != null)
            {
                foreach (Individual ch in pomFam.Children)
                {
                    ch.ParentFamilyId.Remove(pomFam);
                }
            }
            if (pomFam.HusbandId != null)
            {
                pomFam.HusbandId.SpouseFamilyId.Remove(pomFam);
            }
            if (pomFam.WifeId != null)
            {
                pomFam.WifeId.SpouseFamilyId.Remove(pomFam);
            }
            aktualniOsoba = rodokmeny[aktualniRodokmen - 1].getOsoba(aktualniOsoba.Id);
            rodokmeny[aktualniRodokmen - 1].OdeberRodinu(pomFam);
            pomFam = null;
            return true;
        }

        internal bool OdeberOsobuZRodiny(Individual os, Family pomFam)
        {
            if (pomFam == null || os == null) return false;
            //SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            //odebereme z rodiny
            if (pomFam.Children != null)
            {
                pomFam.Children.Remove(os);
            }
            if (pomFam.HusbandId != null && pomFam.HusbandId == os)
            {
                pomFam.HusbandId = null;
            }
            if (pomFam.WifeId != null && pomFam.WifeId == os)
            {
                pomFam.WifeId = null;
            }
            //kontrola prazdnosti rodiny
            bool prazdno = true;
            if (pomFam.HusbandId != null && pomFam.HusbandId.Id >= 0)
            {
                prazdno = false;
            }
            if (pomFam.WifeId != null && pomFam.WifeId.Id >= 0)
            {
                prazdno = false;
            }
            if (prazdno && pomFam.Children != null && pomFam.Children.Count > 0)
            {
                foreach (Individual ch in pomFam.Children)
                {
                    ch.ParentFamilyId.Remove(pomFam);
                }
                pomFam.Children.Clear();
            }
            //odebereme z osoby
            if (os.SpouseFamilyId != null)
            {
                os.SpouseFamilyId.Remove(pomFam);
            }
            if (os.ParentFamilyId != null)
            {
                os.ParentFamilyId.Remove(pomFam);
            }
            if (prazdno)
            {
                OdeberRodinuZRodokmenu(pomFam);
            }

            return true;
        }

        internal bool ZmenitPartneryVRodineJakoPartnera(Individual os1, Individual os2, Family pomFam)
        {
            if (pomFam == null || os1 == null || os2 == null) return false;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            if (pomFam.HusbandId != null && pomFam.HusbandId == os1)
            {
                if (pomFam.WifeId != null && pomFam.WifeId == os2)
                {
                    return false;
                }
                else if (pomFam.WifeId != null && pomFam.WifeId != os2)
                {
                    return VymenOsobuRodiceVRodine(pomFam, os2, false);
                }
            }
            else if (pomFam.WifeId != null && pomFam.WifeId == os1)
            {
                if (pomFam.HusbandId != null && pomFam.HusbandId == os2)
                {
                    return false;
                }
                else if (pomFam.HusbandId != null && pomFam.HusbandId != os2)
                {
                    return VymenOsobuRodiceVRodine(pomFam, os2, true);
                }
            }
            else if (pomFam.HusbandId != null && pomFam.HusbandId == os2)
            {
                if (pomFam.WifeId != null && pomFam.WifeId == os1)
                {
                    return false;
                }
                else if (pomFam.WifeId != null && pomFam.WifeId != os1)
                {
                    return VymenOsobuRodiceVRodine(pomFam, os1, false);
                }
            }
            else if (pomFam.WifeId != null && pomFam.WifeId == os2)
            {
                if (pomFam.HusbandId != null && pomFam.HusbandId == os1)
                {
                    return false;
                }
                else if (pomFam.HusbandId != null && pomFam.HusbandId != os1)
                {
                    return VymenOsobuRodiceVRodine(pomFam, os1, true);
                }
            }
            return false;
        }
        internal bool ZmenitPartneryVRodineJakoPartneraSDitem(Individual rodic, Individual dite, Family pomFam, bool muz)
        {
            if (rodic == null || dite == null) return false;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);//historie
            if (pomFam == null)
            {
                pomFam = VytvorNovouRodinu();
                SpravceHist.NactiPredchozi();//vratime zbytecnou historii
            }
            if (pomFam == null)
            {
                NastavRodokmenPrezZmenou();
                return false;
            }
            if (pomFam.Children != null && !pomFam.Children.Contains(dite))
            {
                pomFam.Children.Add(dite);
                dite.ParentFamilyId.Add(pomFam);
            }
            else if (pomFam.Children == null)
            {
                pomFam.Children = new List<Individual>();
                pomFam.Children.Add(dite);
                dite.ParentFamilyId.Add(pomFam);
            }
            return VymenOsobuRodiceVRodine(pomFam, rodic, muz);
        }

        private bool VymenOsobuRodiceVRodine(Family pomFam, Individual os, bool isMuz)
        {
            if (os == null || aktualniOsoba == null) return false;
            if (pomFam == null)
            {
                pomFam = VytvorNovouRodinu();
                if (PridatOsobuDoRodinyJakoPartnera(os, pomFam))
                {
                    //pomFam.Children.Add(aktualniOsoba);//nevim proč jsem to tu dal
                    //aktualniOsoba.SpouseFamilyId.Add(pomFam);//nevím proč tu
                    return true;
                }
                else
                {
                    return false;
                }
            }

            if (isMuz)
            {
                if (pomFam.HusbandId != null && pomFam.HusbandId.Id >= 0)
                {
                    pomFam.HusbandId.SpouseFamilyId.Remove(pomFam);
                    pomFam.HusbandId = os;
                }
                else
                {
                    pomFam.HusbandId = os;
                }
                if (!os.SpouseFamilyId.Contains(pomFam))
                {
                    os.SpouseFamilyId.Add(pomFam);
                }
            }
            else
            {
                if (pomFam.WifeId != null && pomFam.WifeId.Id >= 0)
                {
                    pomFam.WifeId.SpouseFamilyId.Remove(pomFam);
                    pomFam.WifeId = os;
                }
                else
                {
                    pomFam.WifeId = os;
                }
                if (!os.SpouseFamilyId.Contains(pomFam))
                {
                    os.SpouseFamilyId.Add(pomFam);
                }
            }

            return true;
        }

        public Family VytvorNovouRodinu()
        {
            Rodokmen r = rodokmeny[aktualniRodokmen - 1];
            if (r == null) return null;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            Family f = r.VytvorRodinu();
            return f;
        }

        internal bool ZmenitVRodineJakoDite(Individual dite, Family pomFam)
        {
            if (pomFam == null || dite == null) return false;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            if (dite.ParentFamilyId != null && dite.ParentFamilyId.Count > 0)
            {
                int pocetOpakovani = 0;
                while (dite.ParentFamilyId.Count > 0)
                {
                    this.OdeberOsobuZRodiny(dite, dite.ParentFamilyId[0]);
                    pocetOpakovani++;
                    if (pocetOpakovani > 100)
                    {
                        SpravceHist.NactiPredchozi();
                        return false;
                    }
                }
                /*foreach (Family f in dite.ParentFamilyId)//chyba
                {
                    this.OdeberOsobuZRodiny(dite, pomFam);
                }*/
            }
            pomFam.Children.Add(dite);
            dite.ParentFamilyId.Add(pomFam);

            return true;
        }

        internal bool UlozVerziRodokmenu()
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return false;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            return true;
        }

        internal bool NastavRodokmenPrezZmenou()
        {
            if (rodokmeny[aktualniRodokmen - 1] == null
                || SpravceHist == null) return false;
            Rodokmen r = SpravceHist.NactiPredchozi();

            if (r == null) return false;
            rodokmeny[aktualniRodokmen - 1] = r;
            return true;
        }

        internal bool NastavRodokmenPoZmene()
        {
            if (rodokmeny[aktualniRodokmen - 1] == null
                || SpravceHist == null) return false;
            Rodokmen r = SpravceHist.NactiDalsi();

            if (r == null) return false;
            rodokmeny[aktualniRodokmen - 1] = r;
            return true;
        }

        internal List<System.Windows.Forms.ListViewItem> getRodinyListBoxItem(Individual dite)
        {
            List<System.Windows.Forms.ListViewItem> seznam = new List<System.Windows.Forms.ListViewItem>();
            List<Family> rodinyRodicuDitete = new List<Family>();
            if (rodokmeny[aktualniRodokmen - 1] == null) return seznam;
            if (dite == null
                || dite.ParentFamilyId == null
                || dite.ParentFamilyId.Count < 1
                /*||(
                (dite.ParentFamilyId[0].WifeId == null|| dite.ParentFamilyId[0].WifeId.Id<0)
                &&
                (dite.ParentFamilyId[0].HusbandId == null || dite.ParentFamilyId[0].HusbandId.Id < 0)
                )*/) return seznam;

            if (dite.ParentFamilyId[0].WifeId != null
                && dite.ParentFamilyId[0].WifeId.Id >= 0
                && dite.ParentFamilyId[0].WifeId.SpouseFamilyId != null)
            {
                rodinyRodicuDitete.AddRange(dite.ParentFamilyId[0].WifeId.SpouseFamilyId);
            }
            if (dite.ParentFamilyId[0].HusbandId != null
                && dite.ParentFamilyId[0].HusbandId.Id >= 0
                && dite.ParentFamilyId[0].HusbandId.SpouseFamilyId != null)
            {
                foreach (Family f in dite.ParentFamilyId[0].HusbandId.SpouseFamilyId)
                {
                    if (!rodinyRodicuDitete.Contains(f))
                    {
                        rodinyRodicuDitete.Add(f);
                    }
                }
            }
            foreach (Family f in rodinyRodicuDitete)
            {
                System.Windows.Forms.ListViewItem item = new System.Windows.Forms.ListViewItem(f.Id.ToString());
                String popis = "";
                if (f.HusbandId != null && f.HusbandId.Id >= 0)
                {
                    popis += f.HusbandId.dejCelePrijmeniJmenoNarozeni();
                }
                else
                {
                    popis += "Otec neznámý";
                }
                popis += " - ";
                if (f.WifeId != null && f.WifeId.Id >= 0)
                {
                    popis += f.WifeId.dejCelePrijmeniJmenoNarozeni();
                }
                else
                {
                    popis += "Matka neznámá";
                }
                item.SubItems.Add(popis);
                item.Tag = f;
                seznam.Add(item);
            }
            return seznam;
        }

        internal bool PridatDoRodinySourozence(Individual aktual, Individual sourozenec, Family pomFam)
        {
            if (aktual == null || sourozenec == null || pomFam == null) return false;
            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);//historie
            /*if (pomFam == null)
            {
                pomFam = VytvorNovouRodinu();
                SpravceHist.NactiPredchozi();//vratime zbytecnou historii
            }
            if (pomFam == null)
            {
                NastavRodokmenPrezZmenou();
                return false;
            }*/
            if (pomFam.Children != null && !pomFam.Children.Contains(sourozenec))
            {
                pomFam.Children.Add(sourozenec);
                sourozenec.ParentFamilyId.Add(pomFam);
            }
            else if (pomFam.Children == null)
            {
                pomFam.Children = new List<Individual>();
                pomFam.Children.Add(sourozenec);
                sourozenec.ParentFamilyId.Add(pomFam);
            }
            else
            {
                return false;
            }
            return true;
        }

        internal List<System.Windows.Forms.ListViewItem> getRodinyVsechnyListBoxItem()
        {
            List<System.Windows.Forms.ListViewItem> seznam = new List<System.Windows.Forms.ListViewItem>();
            List<Family> rodinyRodicuDitete = new List<Family>();
            if (rodokmeny[aktualniRodokmen - 1] == null) return seznam;
            if (rodokmeny[aktualniRodokmen - 1].getRodiny() == null) return seznam;

            foreach (Family f in rodokmeny[aktualniRodokmen - 1].getRodiny())
            {
                System.Windows.Forms.ListViewItem item = new System.Windows.Forms.ListViewItem(f.Id.ToString());
                String popis = "";
                if (f.HusbandId != null && f.HusbandId.Id >= 0)
                {
                    popis += f.HusbandId.dejCelePrijmeniJmenoNarozeni();
                }
                else
                {
                    popis += "Otec neznámý";
                }
                popis += " - ";
                if (f.WifeId != null && f.WifeId.Id >= 0)
                {
                    popis += f.WifeId.dejCelePrijmeniJmenoNarozeni();
                }
                else
                {
                    popis += "Matka neznámá";
                }
                item.SubItems.Add(popis);
                item.Tag = f;
                seznam.Add(item);
            }
            return seznam;
        }

        internal List<System.Windows.Forms.ListViewItem> getDokumentyVsechnyListBoxItem(List<ObjFile> pole, int volba)
        {
            List<System.Windows.Forms.ListViewItem> seznam = new List<System.Windows.Forms.ListViewItem>();
            if (rodokmeny[aktualniRodokmen - 1] == null) return seznam;
            if (pole == null || volba < 0 || volba > 3) return seznam;

            foreach (ObjFile o in pole)
            {

                if (volba == 0
                    || (volba == 2 && o.Type != null && o.Type.Trim().ToUpper().Equals("PHOTO"))
                    || (volba == 2 && o.Prim)
                    || (volba == 3 && o.Type != null && o.Type.Trim().ToUpper().Equals("BOOK")))
                {
                    System.Windows.Forms.ListViewItem item = new System.Windows.Forms.ListViewItem(o.Title);

                    /*String popis = "";
                    item.SubItems.Add(popis);*/


                    item.Tag = o;
                    seznam.Add(item);
                }
            }
            return seznam;
        }

        internal bool VytvorNovyDokument(int p)
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return false;
            if (aktualniOsoba == null) return false;
            if (p < 0 || p > 3) return false;

            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            ObjFile o = new ObjFile(p);
            o.Title = "Nový";
            if (p == 1) {
                o.Type = "DOC";
            }else if (p == 2) {
                o.Type = "PHOTO";
            }
            else if (p == 3)
            {
                o.Type = "BOOK";
            }
            else {
                o.Type = "";
            }
            if (aktualniOsoba.Soubory == null)
            {
                aktualniOsoba.Soubory = new List<ObjFile>();
            }
            aktualniOsoba.Soubory.Add(o);
            return true;
        }

        internal bool SmazDokumentNaAktualniOsobe(ObjFile obj)
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return false;
            if (aktualniOsoba == null) return false;
            if (obj == null) return false;
            if (aktualniOsoba.Soubory == null) return false;

            SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);

            if (File.Exists(obj.Path))
            {
                File.Delete(obj.Path);
            }
            return aktualniOsoba.Soubory.Remove(obj);
        }

        internal string UlozitSoubor(Individual individual, ObjFile pom, bool kopirovat)
        {
            if (rodokmeny[aktualniRodokmen - 1] == null) return "";
            if (individual == null || individual.Id < 0) return "";
            if (pom == null || !File.Exists(pom.Path)) return "";
            if (aktualniOsoba.Soubory == null) return "";

            //SpravceHist.ulozit(rodokmeny[aktualniRodokmen - 1]);
            String slozka = DejSlozku(cestaKRodokmenu);
            String nazev = DejNazev(pom.Path);
            string novaCesta = slozka + "dokumenty\\" + individual.Id.ToString() + "\\";
            try
            {
                if (String.IsNullOrWhiteSpace(slozka)) return "";
                Directory.CreateDirectory(novaCesta);
                if (!File.Exists(novaCesta + nazev))
                {
                    File.Copy(pom.Path, novaCesta + nazev);
                }
                pom.Path = novaCesta + nazev;
            }
            catch (Exception)
            {
                return "";
            }
            return pom.Path;
        }

        private string DejNazev(string cestaKRodokmenu)
        {
            if (string.IsNullOrWhiteSpace(cestaKRodokmenu)) return "";
            string pom = cestaKRodokmenu;
            string vysledek = "";
            while (pom.Length > 0 && !pom[pom.Length - 1].Equals('\\'))
            {
                vysledek = pom[pom.Length - 1] + vysledek;
                pom = pom.Remove(pom.Length - 1);
            }

            return vysledek;
        }

        private string DejSlozku(string cestaKRodokmenu)
        {
            if (string.IsNullOrWhiteSpace(cestaKRodokmenu)) return "";
            string pom = cestaKRodokmenu;
            while (pom.Length > 0 && !pom[pom.Length - 1].Equals('\\'))
            {
                pom = pom.Remove(pom.Length - 1);
            }

            return pom;
        }
    }
}
