﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace RodokmenDiplomka
{
    [Serializable]
    public class Subm:IGedZaznam
    {
        private int id;

        public int Id
        {
            get { return id; }
            set { id = value; }
        }
        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        private string addr;

        public string Addr
        {
            get { return addr; }
            set { addr = value; }
        }
        public Subm() 
        {
            Id = -1;
        }

        public void ZatridToken(GedToken t)
        {
            if (Regex.IsMatch(t.Typ, "^@"))
            {
                int pom = Int32.Parse(t.Typ.Substring(5, t.Typ.Length - 6));
                Id = pom;
            }
            else if (Regex.IsMatch(t.Typ, "^NAME"))
            {
                Name = t.Pole;
            }
            else if (Regex.IsMatch(t.Typ, "^ADDR"))
            {
                Addr = t.Pole;
            }
            else
            {
                throw new Exception("Chybné rozhodování subm");
            }
        }


        public void Exportovat(System.IO.StreamWriter sw)
        {
            if (Id >= 0) sw.WriteLine("0 @SUBM" + Id + "@ SUBM");
            if (!String.IsNullOrEmpty(Name)) sw.WriteLine("1 NAME " + Name);
            if (!String.IsNullOrEmpty(Addr)) sw.WriteLine("1 ADDR " + Addr);
        }
    }
}
