﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RodokmenDiplomka.Data;
using RodokmenDiplomka.Forms;
using RodokmenDiplomka.Function;
using System.Windows.Threading;
using System.IO;

namespace RodokmenDiplomka
{
    public partial class Form1 : Form
    {
        private SpravaRodokmenu sprava;
        private NastaveniIndividual nastaveniUzivatel;
        SpravceHistorie sh = new SpravceHistorie();
        public Form1()
        {
            InitializeComponent();

            sprava = new SpravaRodokmenu();

            PovolitPrvky();
            if (!NactiVsechnaNastaveni())
            {
                nastaveniUzivatel = new NastaveniIndividual();
            }
            NaplnitCombaAListy();
        }

        private bool NactiVsechnaNastaveni()
        {
            BinExportImport bEI = new BinExportImport();
            nastaveniUzivatel = bEI.Deserializace<NastaveniIndividual>("nast_uzivatel.bin");

            return true;
        }

        private bool UlozVsechnaNastaveni()
        {
            BinExportImport bEI = new BinExportImport();

            bEI.Serializace<NastaveniIndividual>(nastaveniUzivatel, "nast_uzivatel.bin");

            return true;
        }

        private void NaplnitCombaAListy()
        {
            BindingSource bsNarozeni = new BindingSource();
            BindingSource bsUmrti = new BindingSource();
            BindingSource bsPohrbeni = new BindingSource();
            BindingSource bsSvatby = new BindingSource();
            bsNarozeni.DataSource = sprava.dejMista();
            bsUmrti.DataSource = bsNarozeni.DataSource;
            bsPohrbeni.DataSource = bsNarozeni.DataSource;
            bsSvatby.DataSource = bsNarozeni.DataSource;

            comboBoxMistoNarozeni.DataSource = bsNarozeni;
            comboBoxMistoPohrbeni.DataSource = bsPohrbeni;
            comboBoxMistoUmrti.DataSource = bsUmrti;
            comboBox1MistoSvatby.DataSource = bsSvatby;

            BindingSource bsPriciny = new BindingSource();
            bsPriciny.DataSource = sprava.dejPricinyUmrti();
            comboBoxPricina.DataSource = bsPriciny;
            NastavTamAZpet();
        }

        private void toolStripMenuItemKonec_Click(object sender, EventArgs e)
        {
            if (!UlozVsechnaNastaveni())
            {

            }
            Application.Exit();
        }

        private void toolStripMenuItemImportGED55_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Vyberte soubor";
            ofd.Filter = "ged 5.5 (*.ged)|*.ged";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                var t = new System.Threading.Thread(() => Application.Run(new WaitLog()));
                t.SetApartmentState(System.Threading.ApartmentState.STA);
                t.Start();
                /*WaitLog wait = new WaitLog();
                wait.Show();
                wait.Refresh();*/
                sprava.ImportGed55(ofd.FileName);
                NaplnListBox();
                NaplnitCombaAListy();
                //wait.Close();
                if (sprava.ExportAktualnihoRodokmenuDoBin(""))
                {

                }
                t.Abort();
            }
            toolStripMenuItemUlozitJako_Click(sender, e);
            PovolitPrvky();
        }

        private void NaplnListBox()
        {
            List<ListViewItem> pom = sprava.getOsobyListBoxItem(1);
            listViewSeznamOsob.Items.Clear();
            foreach (ListViewItem item in pom)
            {
                listViewSeznamOsob.Items.Add(item);
            }
            //if (listViewSeznamOsob.Items.Count < 1) listViewSeznamOsob.Items.Add(new ListViewItem("Rodokmen je prázdný"));
        }

        private void toolStripMenuItemExportGED55_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Title = "Vyberte umístění";
            sfd.Filter = "ged 5.5 (*.ged)|*.ged";
            sfd.RestoreDirectory = true;
            //sfd.CheckFileExists = true;
            sfd.CheckPathExists = true;
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                sprava.ExportGed55(sfd.FileName);
                MessageBox.Show("Export proběhl úspěšně");
            }
        }

        private void toolStripMenuItemMistaVybraneOsoby_Click(object sender, EventArgs e)
        {
            this.Refresh();
            //BackgroundWorker bw;
            /*using (ProgressForm p = new ProgressForm(this))
            {
                //Do Some Work
            }*/

            //MapForm ff = new MapForm("Místa vybrané osoby", sprava.dejMistaPlaceVybraneOsoby());
            //ff.Show();
            /*var t = new System.Threading.Thread(() => Application.Run(new MapForm("Místa vybrané osoby", sprava.dejMistaPlaceVybraneOsoby())));
            t.SetApartmentState(System.Threading.ApartmentState.STA);
            t.Start();
            */
            try
            {
                MapForm mf = new MapForm("Místa vybrané osoby", sprava.dejMistaPlaceVybraneOsoby(), false);
                mf.ShowDialog();
            }
            catch (Exception)
            {
                MessageBox.Show("Chyba při spouštění map. Zkuste prosím pustit znovu!");
            }
        }

        private void toolStripMenuItemVsechnaMista_Click(object sender, EventArgs e)
        {
            this.Refresh();
            List<Place> pom = new List<Place>();
            pom = sprava.dejMistaPlace();


            //MapForm ff =  new MapForm("Místa vybrané osoby", pom);
            //ff.Show();
            /*Dispatcher.Invoke((Action)(() =>
    {
            var t = new System.Threading.Thread(() => Application.Run(new MapForm("Všechna ohledaná místa v rodokmenu", pom)));
            t.SetApartmentState(System.Threading.ApartmentState.STA);
            t.Start();
    }));*/
            try
            {
                MapForm mf = new MapForm("Všechna dohledaná místa v rodokmenu", sprava.dejMistaPlace(), false);
                mf.ShowDialog();
            }
            catch (Exception)
            {
                MessageBox.Show("Chyba při spouštění map. Zkuste prosím pustit znovu!");
            }
        }

        private void listViewSeznamOsob_SelectedIndexChanged(object sender, EventArgs e)
        {
            VynulujOsobu();
            //VynulujRodinu();
            VynulujVse();
            listViewPartneriARodiny.Items.Clear();
            if (listViewSeznamOsob.SelectedIndices.Count > 0)
            {
                //sprava.ZmenAktualniOsobu(listViewSeznamOsob.SelectedIndices[0]);
                sprava.ZmenAktualniOsobu((Individual)listViewSeznamOsob.SelectedItems[0].Tag);
            }
            else
            {
                sprava.ZmenAktualniOsobu(null);
            }
            NaplnPoleOsoby(sprava.getAktualniOsoba());
        }

        private void VynulujOsobu()
        {
            toolStripTextBoxJmenoAktualniOsobyHlavicka.Text = "";
            NastavComboBox(comboBoxTitulPred, "");
            NastavComboBox(comboBoxTitulZa, "");

            textBoxJmeno.Text = "";
            textBoxPrijmeni.Text = "";
            textBoxJmenoZaSvobodna.Text = "";
            comboBoxPohlavi.SelectedIndex = 0;
            checkBoxPriblizneNarozen.Checked = false;
            checkBoxPriblizneNarozen.Checked = false;
            textBoxDatumNarozeni.Text = "";
            NastavComboBox(comboBoxMistoNarozeni, "");
            comboBoxUmrti.SelectedIndex = 0;
            checkBoxPriblizneUmrel.Checked = false;
            textBoxDatumUmrti.Text = "";
            NastavComboBox(comboBoxMistoUmrti, "");
            NastavComboBox(comboBoxPricina, "");
            NastavComboBox(comboBoxMistoPohrbeni, "");
            comboBoxOtec.Items.Clear();
            comboBoxMatka.Items.Clear();
            checkBoxUzamknoutOsobu.Checked = false;
            //----------------------------------------------------------------  list rodin
            VynulujRodinu();
            listViewSourozenci.Items.Clear();
            listViewPartneriARodiny.Items.Clear();
            //--------------------------- list ostatni
            VynulujOstatni();
            textBoxNarodnost.Text = "";
            textBoxVyznani.Text = "";
            labelIdOsoby.Text = "-";
        }

        private void NaplnPoleOsoby(Individual os)
        {
            toolStripTextBoxJmenoAktualniOsobyHlavicka.Text = "";
            if (os == null) return;
            toolStripTextBoxJmenoAktualniOsobyHlavicka.Text = os.dejCelePrijmeniJmeno();
            NastavComboBox(comboBoxTitulPred, os.TitulPred);
            NastavComboBox(comboBoxTitulZa, os.TitulZa);
            if (os == null) return;

            if (!String.IsNullOrEmpty(os.Firstname))
            {
                textBoxJmeno.Text = os.Firstname;
            }
            else
            {
                textBoxJmeno.Text = "";
            }
            if (!String.IsNullOrEmpty(os.Surname))
            {
                textBoxPrijmeni.Text = os.Surname;
            }
            else
            {
                textBoxPrijmeni.Text = "";
            }
            if (!String.IsNullOrEmpty(os.MaridName))
            {
                textBoxJmenoZaSvobodna.Text = os.MaridName;
            }
            else
            {
                textBoxJmenoZaSvobodna.Text = "";
            }
            if (!String.IsNullOrEmpty(os.Sex))
            {
                if (os.Sex.Contains("M"))
                {
                    comboBoxPohlavi.SelectedIndex = 1;
                }
                else if (os.Sex.Contains("F"))
                {
                    comboBoxPohlavi.SelectedIndex = 2;
                }
                else
                {
                    comboBoxPohlavi.SelectedIndex = 0;
                }
            }
            else
            {
                comboBoxPohlavi.SelectedIndex = 0;
            }
            checkBoxPriblizneNarozen.Checked = false;
            if (!String.IsNullOrEmpty(os.BirthDate))
            {
                textBoxDatumNarozeni.Text = os.BirthDate;
                checkBoxPriblizneNarozen.Checked = !os.PresnostNarozeni;
            }
            else
            {
                textBoxDatumNarozeni.Text = "";
            }

            NastavComboBox(comboBoxMistoNarozeni, os.BirthPlace);

            if (!String.IsNullOrEmpty(os.Died))
            {
                if (os.Died.Contains("Y"))
                {
                    comboBoxUmrti.SelectedIndex = 2;
                }
                else if (os.Died.Contains("N"))
                {
                    comboBoxUmrti.SelectedIndex = 1;
                }
                else
                {
                    comboBoxUmrti.SelectedIndex = 0;
                }
            }
            else
            {
                comboBoxUmrti.SelectedIndex = 0;
            }
            checkBoxPriblizneUmrel.Checked = false;
            if (!String.IsNullOrEmpty(os.DiedDate))
            {
                textBoxDatumUmrti.Text = os.DiedDate;
                checkBoxPriblizneUmrel.Checked = !os.PresnostUmrti;
            }
            else
            {
                textBoxDatumUmrti.Text = "";
            }

            NastavComboBox(comboBoxMistoUmrti, os.DiedPlace);

            NastavComboBox(comboBoxPricina, os.DiedCause);

            NastavComboBox(comboBoxMistoPohrbeni, os.BuriPlace);
            //nastavComboBox(comboBoxMistoPohrbeni, os.ResiPlace);
            /*comboBoxMistoPohrbeni.Items.Clear();
            comboBoxMistoPohrbeni.Items.Insert(0, os.mistopohrbu);*/

            comboBoxOtec.Items.Clear();
            comboBoxOtec.Items.Insert(0, os.dejOtce());
            NastavComboBox(comboBoxOtec, os.dejOtce());

            comboBoxMatka.Items.Clear();
            comboBoxMatka.Items.Insert(0, os.dejMatku());
            NastavComboBox(comboBoxMatka, os.dejMatku());

            checkBoxUzamknoutOsobu.Checked = os.Uzamceno;

            bool nalezeno = false;
            if (os.Soubory != null && os.Soubory.Count > 0)
            {
                foreach (ObjFile obj in os.Soubory)
                {
                    if (obj.Path != null && File.Exists(obj.Path) && obj.Prim != null && obj.Prim)
                    {
                        try
                        {
                            pictureBoxProfilFoto.Image = Image.FromFile(obj.Path);
                            nalezeno = true;
                            break;
                        }
                        catch (Exception)
                        {
                            pictureBoxProfilFoto.Image = pictureBoxProfilFoto.InitialImage;
                        }
                    }
                }
            }
            if (!nalezeno)
            {
                pictureBoxProfilFoto.Image = pictureBoxProfilFoto.InitialImage;
            }
            //----------------------------------------------------------------  list rodin
            VynulujRodinu();
            List<Family> rodinyOsobyLive = os.ParentFamilyId;
            List<Family> rodinyOsobyMarrid = os.SpouseFamilyId;
            listViewSourozenci.Items.Clear();
            foreach (Family rodina in rodinyOsobyLive)//vlastni nevlastni sourozenci
            {
                foreach (Individual ch in rodina.Children)
                {
                    if (ch == os) continue;
                    ListViewItem item1 = new ListViewItem(ch.Id.ToString());
                    item1.SubItems.Add(ch.dejCelePrijmeniJmenoNarozeni());
                    item1.Tag = ch;
                    listViewSourozenci.Items.Add(item1);
                }
            }

            listViewPartneriARodiny.Items.Clear();
            foreach (Family rodina in rodinyOsobyMarrid)//vlastni prisvojene deti
            {
                if (rodina.HusbandId != null && rodina.HusbandId == os && rodina.WifeId != null)
                {
                    NastavListViewItem(listViewPartneriARodiny, rodina.WifeId.Id.ToString(), rodina.WifeId.dejCelePrijmeniJmenoNarozeni(), rodina);
                }
                else if (rodina.WifeId != null && rodina.WifeId == os && rodina.HusbandId != null)
                {
                    NastavListViewItem(listViewPartneriARodiny, rodina.HusbandId.Id.ToString(), rodina.HusbandId.dejCelePrijmeniJmenoNarozeni(), rodina);
                }

                else if (rodina.HusbandId != null || rodina.WifeId != null)
                {
                    NastavListViewItem(listViewPartneriARodiny, "-", "neuvedena", rodina);
                }
                else
                {
                    NastavListViewItem(listViewPartneriARodiny, "-", "rodina bez rodičů", rodina);
                }
            }
            if (rodinyOsobyMarrid.Count > 0)
            {
                listViewPartneriARodiny.Items[0].Selected = true;
            }
            //------------------------- list data

            //--------------------------- list ostatni
            VynulujOstatni();
            textBoxNarodnost.Text = os.National;
            textBoxVyznani.Text = os.Religion;

            labelIdOsoby.Text = os.Id.ToString();

            if (os.WWW != null && os.WWW.Count >= 2)
            {
                textBoxWww1.Text = os.WWW[0];
                textBoxWww2.Text = os.WWW[1];
            }
            else if (os.WWW != null && os.WWW.Count == 1)
            {
                textBoxWww1.Text = os.WWW[0];
                textBoxWww2.Text = "";
            }
            else
            {
                textBoxWww1.Text = "";
                textBoxWww2.Text = "";
            }
            if (os.Tel != null && os.Tel.Count >= 2)
            {
                textBoxTelefon1.Text = os.Tel[0];
                textBoxTelefon2.Text = os.Tel[1];
            }
            else if (os.Tel != null && os.Tel.Count == 1)
            {
                textBoxTelefon1.Text = os.Tel[0];
                textBoxTelefon2.Text = "";
            }
            else
            {
                textBoxTelefon1.Text = "";
                textBoxTelefon2.Text = "";
            }
            if (os.Email != null && os.Email.Count >= 2)
            {
                textBoxEmail1.Text = os.Email[0];
                textBoxEmail2.Text = os.Email[1];
            }
            else if (os.Email != null && os.Email.Count == 1)
            {
                textBoxEmail1.Text = os.Email[0];
                textBoxEmail2.Text = "";
            }
            else
            {
                textBoxEmail1.Text = "";
                textBoxEmail2.Text = "";
            }

            if (os.NotesCont != null && os.NotesCont.Count > 0)
            {
                textBoxPoznamkyKOsobe.Text = "";
                textBoxPoznamkyKOsobe.Lines = os.NotesCont.ToArray<string>();
                /*foreach (string c in os.NotesCont)
                {
                    textBoxPoznamkyKOsobe.Text += c ;
                }*/
            }
            else
            {
                textBoxPoznamkyKOsobe.Text = "";
            }
            //--------------------------- list Matriky
            VynulujMatriky();

            if (os.Soubory != null && os.Soubory.Count > 0)
            {
                foreach (System.Windows.Forms.ListViewItem item in sprava.getDokumentyVsechnyListBoxItem(os.Soubory, 3))
                {
                    listViewMatrikaSeznam.Items.Add(item);
                }
                try
                {
                    if (listViewMatrikaSeznam.Items.Count > 0)
                    {
                        listViewMatrikaSeznam.Items[0].Selected = true;
                    }
                }
                catch (Exception) { }
            }
            //--------------------------- list Fotky
            VynulujFotky();

            if (os.Soubory != null && os.Soubory.Count > 0)
            {
                foreach (System.Windows.Forms.ListViewItem item in sprava.getDokumentyVsechnyListBoxItem(os.Soubory, 2))
                {
                    listViewFotkaSeznam.Items.Add(item);
                }
                try
                {
                    if (listViewFotkaSeznam.Items.Count > 0)
                    {
                        listViewFotkaSeznam.Items[0].Selected = true;
                    }
                }
                catch (Exception) { }
            }
            //--------------------------- list Dokumenty
            VynulujDokumenty();
            if (os.Soubory != null && os.Soubory.Count > 0)
            {
                foreach (System.Windows.Forms.ListViewItem item in sprava.getDokumentyVsechnyListBoxItem(os.Soubory, 0))
                {
                    listViewDokumentSeznam.Items.Add(item);
                }
                try
                {
                    if (listViewDokumentSeznam.Items.Count > 0)
                    {
                        listViewDokumentSeznam.Items[0].Selected = true;
                    }
                }
                catch (Exception) { }
            }
        }

        private void VynulujMatriky()
        {
            pictureBoxMatrikaNahled.Image = null;
            textBoxMatrikaNazev.Text = "";
            textBoxMatrikaSoubor.Text = "";
            labelMatrikaSOuborNalezen.Text = "Dostupnost neznámá";
            labelMatrikaTyp.Text = "Neznámý";
            //checkBoxFotkaPortret.Checked = false;
            //comboBoxDokumentKategorie.SelectedIndex = 0;
            textBoxMatrikaZdroj.Text = "";
            textBoxMatrikaMistoVeZdroje.Text = "";
            textBoxKoment.Text = "";
            listViewMatrikaSeznam.Clear();
        }

        private void VynulujFotky()
        {
            pictureBoxFotkaNahled.Image = null;
            textBoxFotkaNazev.Text = "";
            textBoxFotkaSoubor.Text = "";
            labelFotkaNalezena.Text = "Dostupnost neznámá";
            labelFotkaTyp.Text = "Neznámý";
            checkBoxFotkaPortret.Checked = false;
            //comboBoxDokumentKategorie.SelectedIndex = 0;
            listViewFotkaSeznam.Clear();
        }

        private void VynulujDokumenty()
        {
            textBoxDokumentNazev.Text = "";
            textBoxDokumentCesta.Text = "";
            labelDokumentNalezen.Text = "Dostupnost neznámá";
            labelDokumentTyp.Text = "Naznámý";
            checkBoxDokumentPortret.Checked = false;
            comboBoxDokumentKategorie.SelectedIndex = 0;
            listViewDokumentSeznam.Clear();
        }

        private void VynulujOstatni()
        {
            textBoxNarodnost.Text = "";
            textBoxVyznani.Text = "";
            labelIdOsoby.Text = "-";

            textBoxWww1.Text = "";
            textBoxWww2.Text = "";
            textBoxTelefon1.Text = "";
            textBoxTelefon2.Text = "";
            textBoxEmail1.Text = "";
            textBoxEmail2.Text = "";
            textBoxPoznamkyKOsobe.Text = "";
        }

        private void NastavListViewItem(ListView lv, string p1, string p2, Object obj)
        {
            ListViewItem item1 = new ListViewItem(p1);
            item1.SubItems.Add(p2);
            item1.Tag = obj;
            lv.Items.Add(item1);
        }

        private void NastavComboBox(ComboBox cb, string hodnota)
        {
            if (!String.IsNullOrEmpty(hodnota))
            {
                if (cb.FindString(hodnota) == -1 && cb.DataSource == null)
                {
                    cb.Items.Add(hodnota);
                    cb.SelectedItem = hodnota;
                }
                cb.SelectedItem = hodnota;
                if (cb.SelectedItem == null)
                {
                    cb.SelectedItem = "";
                }
            }
            else
            {
                //cb.Items.Insert(0, "");
                cb.SelectedIndex = 0;
            }
            //cb.SelectedIndex = 0;
        }

        private void checkBoxUzamknoutOsobu_CheckedChanged(object sender, EventArgs e)
        {
            UzamkniNaListuZakladniUdaje(!checkBoxUzamknoutOsobu.Checked);
        }

        private void UzamkniNaListuZakladniUdaje(bool stav)
        {
            comboBoxTitulPred.Enabled = stav;
            textBoxJmeno.Enabled = stav;
            textBoxPrijmeni.Enabled = stav;
            comboBoxTitulZa.Enabled = stav;
            comboBoxPohlavi.Enabled = stav;
            textBoxJmenoZaSvobodna.Enabled = stav;
            checkBoxPriblizneNarozen.Enabled = stav;
            textBoxDatumNarozeni.Enabled = stav;
            comboBoxMistoNarozeni.Enabled = stav;
            comboBoxUmrti.Enabled = stav;
            checkBoxPriblizneUmrel.Enabled = stav;
            textBoxDatumUmrti.Enabled = stav;
            comboBoxMistoUmrti.Enabled = stav;
            comboBoxMistoPohrbeni.Enabled = stav;
            comboBoxPricina.Enabled = stav;
            comboBoxMistoPohrbeni.Enabled = stav;
            buttonVyberNaOtce.Enabled = stav;
            comboBoxOtec.Enabled = stav;
            buttonVyberNaMatku.Enabled = stav;
            comboBoxMatka.Enabled = stav;
            //--------------------------list rodina

        }

        private void listViewPartneriARodiny_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listViewPartneriARodiny.SelectedItems.Count > 0)
            {
                Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;
                if (pomFam == null) return;

                checkBoxOddani.Checked = pomFam.Marriage;
                checkBoxOddaniPriblizne.Checked = !pomFam.PresnostSvatby;
                textBoxDatumOddani.Text = pomFam.MarriageDate;
                NastavComboBox(comboBox1MistoSvatby, pomFam.MarriagePlace);

                textBoxSvedci.Text = pomFam.Svedci;
                //neco zapomel jsem co
                //--
                checkBoxRozvedeni.Checked = pomFam.Div;
                checkBoxPriblizneRozvedeni.Checked = !pomFam.PresnostRozvodu;
                textBoxDatumRozvodu.Text = pomFam.DivDate;
                foreach (Individual ch in pomFam.Children)
                {
                    NastavListViewItem(listViewVlastniDeti, ch.Id.ToString(), ch.dejCelePrijmeniJmenoNarozeni(), ch);
                }
            }
            else
            {
                VynulujRodinu();
            }
        }
        private void VynulujRodinu()
        {
            checkBoxOddani.Checked = false;
            checkBoxOddaniPriblizne.Checked = false;
            textBoxDatumOddani.Text = "";
            NastavComboBox(comboBox1MistoSvatby, "");

            checkBoxRozvedeni.Checked = false;
            checkBoxPriblizneRozvedeni.Checked = false;
            textBoxDatumRozvodu.Text = "";

            listViewVlastniDeti.Items.Clear();
        }

        private void toolStripMenuItemPridatOsobu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            Individual os = sprava.VytvorNovouOsobu();
            if (os != null)
            {
                NaplnListBox();
                NaplnitCombaAListy();
                NaplnPoleOsoby(os);
            }
            else
            {
                MessageBox.Show("Nemáte vytvořen rodokmen!");
            }
        }

        private void ToolStripMenuItemNovýRodokmen_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Title = "Vyberte umístění a pojmenování vašeho nového projektu!";
            sfd.Filter = "Bin soubor programu (*.bin)|*.bin";
            sfd.RestoreDirectory = true;
            //sfd.CheckFileExists = true;
            sfd.CheckPathExists = true;
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                if (sprava.VytvorNovyRodokmen(sfd.FileName))
                {
                    MessageBox.Show("Rodokmen byl vytvořen.");
                    UdelejPoradek();
                }
            }
        }

        private void VynulujVse()
        {
            toolStripTextBoxJmenoAktualniOsobyHlavicka.Text = "";
            VynulujOsobu();
            VynulujRodinu();
            VynulujZaklad();
            VynulujOstatni();

            VynulujFotky();
            VynulujDokumenty();
            PovolitPrvky();
            NastavTamAZpet();
        }

        private void VynulujZaklad()
        {
            textBoxJmeno.Text = "";
            textBoxPrijmeni.Text = "";
            textBoxJmenoZaSvobodna.Text = "";
            comboBoxPohlavi.SelectedIndex = 0;
            textBoxDatumNarozeni.Text = "";
            checkBoxPriblizneNarozen.Checked = false;
            NastavComboBox(comboBoxMistoNarozeni, "");
            comboBoxUmrti.SelectedIndex = 0;
            checkBoxPriblizneUmrel.Checked = false;
            textBoxDatumUmrti.Text = "";
            NastavComboBox(comboBoxMistoUmrti, "");
            NastavComboBox(comboBoxPricina, "");
            NastavComboBox(comboBoxMistoPohrbeni, "");
            comboBoxOtec.Items.Clear();
            comboBoxMatka.Items.Clear();
            checkBoxUzamknoutOsobu.Checked = false;
            listViewPartneriARodiny.Items.Clear();
            comboBoxOtec.Items.Clear();
            comboBoxMatka.Items.Clear();
        }

        private void toolStripMenuItemVymazatOsobu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() != null)
            {
                sprava.VymazVybranouOsobu(sprava.getAktualniOsoba());
                UdelejPoradek();
            }
            else
            {
                MessageBox.Show("Není vybrána žádná osoba");
            }
            VynulujOsobu();
            UdelejPoradek();
            //VynulujVse();
            listViewSeznamOsob_SelectedIndexChanged(sender, e);
        }

        private void UdelejPoradek()
        {
            VynulujVse();
            NaplnListBox();
            NaplnitCombaAListy();
            if (sprava.getAktualniOsoba() != null)
            {
                NaplnPoleOsoby(sprava.getAktualniOsoba());
            }
        }

        private void ToolStripMenuItemUlozitOsobu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }

            Individual pom = new Individual();
            pom = sprava.getAktualniOsoba();
            if (pom == null)
            {
                MessageBox.Show("Není vybrána žádná osoba");
                return;
            }
            sprava.UlozVerziRodokmenu();
            //nastaveni jednotlivych atributu a nebo zavast docasnou osobu a te to kopirovat pri zmene..
            pom.TitulPred = nastavZComboBoxuPokudNeniPrazdno(comboBoxTitulPred, pom.TitulPred);

            pom.Firstname = textBoxJmeno.Text;
            pom.Surname = textBoxPrijmeni.Text;
            pom.TitulZa = nastavZComboBoxuPokudNeniPrazdno(comboBoxTitulZa, pom.TitulZa);

            if (comboBoxPohlavi.SelectedIndex == 0)
            {
                pom.Sex = "";
            } if (comboBoxPohlavi.SelectedIndex == 1)
            {
                pom.Sex = "M";
            }
            else
            {
                pom.Sex = "F";
            }
            pom.MaridName = textBoxJmenoZaSvobodna.Text;

            pom.BirthDate = textBoxDatumNarozeni.Text;
            pom.PresnostNarozeni = checkBoxPriblizneNarozen.Checked;
            pom.BirthPlace = nastavZComboBoxuPokudNeniPrazdno(comboBoxMistoNarozeni, pom.BirthPlace);

            if (comboBoxUmrti.SelectedIndex == 1)
            {

            }
            else if (comboBoxUmrti.SelectedIndex == 2)
            {
                pom.Died = "Y";
                pom.DiedDate = textBoxDatumUmrti.Text;
                pom.PresnostUmrti = checkBoxPriblizneUmrel.Checked;
                pom.DiedPlace = nastavZComboBoxuPokudNeniPrazdno(comboBoxMistoUmrti, pom.DiedPlace);
                pom.DiedCause = comboBoxPricina.Text;
                pom.BuriPlace = nastavZComboBoxuPokudNeniPrazdno(comboBoxMistoPohrbeni, pom.BuriPlace);
            }
            pom.Uzamceno = checkBoxUzamknoutOsobu.Checked;

            //jeste sem pak narodnost a sparovani s rodinou nebo tak hh
            pom.National = textBoxNarodnost.Text;
            pom.Religion = textBoxVyznani.Text;

            List<string> www = new List<string>();
            if (!string.IsNullOrWhiteSpace(textBoxWww1.Text))
            {
                www.Add(textBoxWww1.Text);
            }
            if (!string.IsNullOrWhiteSpace(textBoxWww2.Text))
            {
                www.Add(textBoxWww2.Text);
            }
            pom.WWW = www;

            List<string> tel = new List<string>();
            if (!string.IsNullOrWhiteSpace(textBoxTelefon1.Text))
            {
                tel.Add(textBoxTelefon1.Text);
            }
            if (!string.IsNullOrWhiteSpace(textBoxTelefon2.Text))
            {
                tel.Add(textBoxTelefon2.Text);
            }
            pom.Tel = tel;

            List<string> email = new List<string>();
            if (!string.IsNullOrWhiteSpace(textBoxEmail1.Text))
            {
                email.Add(textBoxEmail1.Text);
            }
            if (!string.IsNullOrWhiteSpace(textBoxEmail2.Text))
            {
                email.Add(textBoxEmail2.Text);
            }
            pom.Email = email;

            /*string[] lines = textBoxPoznamkyKOsobe.Text.Split(new[] { Environment.NewLine},
                               StringSplitOptions.RemoveEmptyEntries);//nebralo prazdne řádky
            */
            string[] lines = textBoxPoznamkyKOsobe.Lines;
            if (lines != null)
            {
                pom.NotesCont = new List<string>(lines);
            }


            //--------------------------------------- list matriky

            //--------------------------------------- list fotky
            UlozitFotku();
            //--------------------------------------- list DOkumenty
            UlozitDokument();

            if (sprava.UpravAktualniOsobu(pom))
            {
                UdelejPoradek();
                this.Refresh();
            }
            else
            {
                MessageBox.Show("Není vybrána žádná osoba");
            }
        }

        private String nastavZComboBoxuPokudNeniPrazdno(ComboBox cb, string text)
        {
            if (cb.Text != null) text = cb.Text;
            return text;
        }

        private bool ValidujDatum(String d)
        {
            if (!String.IsNullOrWhiteSpace(d))
                if (!sprava.ValidujDatum(d))
                {
                    MessageBox.Show("Datum nema spravny format: DD.MM.RRRR");
                    return false;
                }
            return true;
        }

        private void textBoxDatumNarozeni_Validated(object sender, EventArgs e)
        {
            ValidujDatum(textBoxDatumNarozeni.Text);
        }

        private void textBoxDatumUmrti_Validated(object sender, EventArgs e)
        {
            ValidujDatum(textBoxDatumUmrti.Text);
        }

        private void textBoxDatumOddani_Validated(object sender, EventArgs e)
        {
            ValidujDatum(textBoxDatumOddani.Text);
        }

        private void textBoxDatumRozvodu_Validated(object sender, EventArgs e)
        {
            ValidujDatum(textBoxDatumRozvodu.Text);
            checkBoxRozvedeni.Checked = true;
        }

        private void toolStripMenuItemFilrtPodleJmen_Click(object sender, EventArgs e)
        {
            /*   listViewSeznamOsob.ListViewItemSorter = new Listviews;
   listView.ListViewItemSorter.ColumnsTypeComparer.Add(0, DateTime);
   listView.ListViewItemSorter.ColumnsTypeComparer.Add(1, int);*/
        }

        private void toolStripMenuItemOprogramu_Click(object sender, EventArgs e)
        {
            AboutBoxOProgramu ab = new AboutBoxOProgramu();
            ab.Visible = true;
        }
        private bool ulozZmenu()
        {

            return true;
        }

        private bool vratZmenu()
        {

            return true;
        }

        private void ToolStripMenuItemVizualCasovaOsaIndividual_Click(object sender, EventArgs e)
        {
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou aktuální osobu!");
                return;
            }
            CasovaOsa cs = new CasovaOsa();
            List<Individual> seznam = new List<Individual>();
            seznam.Add(sprava.getAktualniOsoba());
            cs.Osoby = seznam;
            cs.Show();
        }

        private void ToolStripMenuItemVizualCasovaOsaRodokmen_Click(object sender, EventArgs e)
        {
            if (sprava == null || sprava.DejOsoby() == null)
            {
                return;
            }
            CasovaOsa cs = new CasovaOsa();
            cs.Osoby = sprava.DejOsoby();
            cs.Show();
        }

        private void toolStripMenuItemStromPredku_Click(object sender, EventArgs e)
        {
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou aktuální osobu!");
                return;
            }
            VizualizaceStromu vs = new VizualizaceStromu(true);
            vs.VychoziOsoba = sprava.getAktualniOsoba();
            vs.Osoby = sprava.DejOsobyDictionary();
            vs.ShowDialog();
        }

        private void toolStripMenuItemOtevrit_Click(object sender, EventArgs e)
        {
            if (sprava.IsAktualniRodokmen())
            {
                ToolStripMenuItemZavritRodokmen_Click(sender, e);
            }
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Vyberte umístění";
            ofd.Filter = "Bin formát programu (*.bin)|*.bin";
            ofd.RestoreDirectory = true;
            ofd.CheckFileExists = true;
            ofd.CheckPathExists = true;
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    sprava.ImportRodokmenuZBin(ofd.FileName);
                    UdelejPoradek();
                    MessageBox.Show("Načtení proběhlo úspěšně");
                }
                catch (Exception)
                {
                    MessageBox.Show("Načtení selhalo!");
                }
            }
            PovolitPrvky();
        }

        private void ToolStripMenuItemZavritRodokmen_Click(object sender, EventArgs e)
        {
            if (sprava.IsAktualniRodokmen())
            {
                DialogResult retValue = MessageBox.Show("Chcete před uzavřením rodokmen uložit?", "Pozor!", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);

                if (retValue == DialogResult.Yes)
                {
                    Ulozit();
                    sprava.UzavriAktualniRodokmen();
                    UdelejPoradek();
                }
                else if (retValue == DialogResult.No)
                {
                    sprava.UzavriAktualniRodokmen();
                    UdelejPoradek();
                }
                else
                {
                    MessageBox.Show("Žádné změny neprovedeny!");
                }
            }
            else
            {
                MessageBox.Show("Není co uzavřít!", "", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            PovolitPrvky();
        }

        private void Ulozit()
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (!sprava.ExportAktualnihoRodokmenuDoBin())
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Vyberte umístění a pojmenování projektu!";
                sfd.Filter = "Bin soubor programu (*.bin)|*.bin";
                sfd.RestoreDirectory = true;
                //sfd.CheckFileExists = true;
                sfd.CheckPathExists = true;
                if (sfd.ShowDialog() == DialogResult.OK)
                {
                    if (sprava.ExportAktualnihoRodokmenuDoBin(sfd.FileName))
                    {
                        MessageBox.Show("Rodokmen byl uložen!");
                        UdelejPoradek();
                    }
                }
            }
            else
            {
                MessageBox.Show("Rodokmen byl uložen!");
                UdelejPoradek();
            }
            PovolitPrvky();
        }

        private void toolStripMenuItemUlozit_Click(object sender, EventArgs e)
        {
            Ulozit();
        }

        private void toolStripMenuItemUlozitJako_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Title = "Vyberte umístění a pojmenování projektu!";
            sfd.Filter = "Bin soubor programu (*.bin)|*.bin";
            sfd.RestoreDirectory = true;
            //sfd.CheckFileExists = true;
            sfd.CheckPathExists = true;
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                if (sprava.ExportAktualnihoRodokmenuDoBin(sfd.FileName))
                {
                    MessageBox.Show("Rodokmen byl uložen!");
                    UdelejPoradek();
                }
            }
        }

        private void ToolStripMenuItem2Open_Click(object sender, EventArgs e)
        {
            toolStripMenuItemOtevrit_Click(sender, e);
        }

        private void ToolStripMenuItem2ZavritRodokmen_Click(object sender, EventArgs e)
        {
            ToolStripMenuItemZavritRodokmen_Click(sender, e);
        }

        private void ToolStripMenuItem2UlozitRod_Click(object sender, EventArgs e)
        {
            Ulozit();
        }

        private void ToolStripMenuItem2AddOs_Click(object sender, EventArgs e)
        {
            toolStripMenuItemPridatOsobu_Click(sender, e);
        }

        private void ToolStripMenuItem2BeforeOs_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }

            if ((listViewSeznamOsob.SelectedIndices.Count > 0))
            {
                int index = listViewSeznamOsob.SelectedItems[0].Index;
                if (index > 0)
                {
                    //sprava.ZmenAktualniOsobu((Individual)listViewSeznamOsob.SelectedItems[0].Tag);
                    listViewSeznamOsob.SelectedIndices.Clear();
                    listViewSeznamOsob.SelectedIndices.Add(index - 1);
                    //NaplnPoleOsoby(sprava.getAktualniOsoba());
                }
            }
        }

        private void ToolStripMenuItem2NextOs_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }

            if ((listViewSeznamOsob.SelectedIndices.Count > 0))
            {
                int index = listViewSeznamOsob.SelectedItems[0].Index;
                if (index + 1 < listViewSeznamOsob.Items.Count)
                {
                    //sprava.ZmenAktualniOsobu((Individual)listViewSeznamOsob.SelectedItems[0].Tag);
                    listViewSeznamOsob.SelectedIndices.Clear();
                    listViewSeznamOsob.SelectedIndices.Add(index + 1);
                    //NaplnPoleOsoby(sprava.getAktualniOsoba());
                }
            }
        }

        private void ToolStripMenuItem2DellOs_Click(object sender, EventArgs e)
        {
            toolStripMenuItemVymazatOsobu_Click(sender, e);
        }

        private void ToolStripMenuItem2SaveOs_Click(object sender, EventArgs e)
        {
            ToolStripMenuItemUlozitOsobu_Click(sender, e);
        }

        private void comboBoxMistoUmrti_Validated(object sender, EventArgs e)
        {
            comboBoxUmrti.SelectedIndex = 2;
        }

        private void textBoxDatumUmrti_TextChanged(object sender, EventArgs e)
        {
            comboBoxUmrti.SelectedIndex = 2;
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
        }
        private void PovolitPrvky()
        {
            if (sprava == null) return;
            if (sprava.IsAktualniRodokmen())
            {
                tabControlData.Enabled = true;

                //if (listViewPartneriARodiny.Items.Count > 0)
                //{
                ToolStripMenuItem2BeforeOs.Enabled = true;
                ToolStripMenuItem2NextOs.Enabled = true;
                ToolStripMenuItem2DellOs.Enabled = true;
                ToolStripMenuItem2SaveOs.Enabled = true;
                //}
                ToolStripMenuItem2AddOs.Enabled = true;

                ToolStripMenuItem2UlozitRod.Enabled = true;
                ToolStripMenuItem2ZavritRodokmen.Enabled = true;
            }
            else
            {
                tabControlData.Enabled = false;

                tabControlData.Enabled = false;
                ToolStripMenuItem2BeforeOs.Enabled = false;
                ToolStripMenuItem2NextOs.Enabled = false;
                ToolStripMenuItem2DellOs.Enabled = false;
                ToolStripMenuItem2SaveOs.Enabled = false;
                ToolStripMenuItem2AddOs.Enabled = false;

                ToolStripMenuItem2UlozitRod.Enabled = false;
                ToolStripMenuItem2ZavritRodokmen.Enabled = false;
            }
        }

        private void toolStripMenuItemNastUzivatele_Click(object sender, EventArgs e)
        {
            Nastaveni n = new Nastaveni();
            if (nastaveniUzivatel != null)
            {
                n.NastaveniIndiv = nastaveniUzivatel;
            }
            n.ShowDialog();

            ZmenProgramPodleNastaveni(n.NastaveniIndiv);
        }

        private void ZmenProgramPodleNastaveni(NastaveniIndividual nastaveni)
        {
            nastaveniUzivatel = nastaveni;
        }

        private void ToolStripMenuItemPridatRodinu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            Family f = sprava.VytvorNovouRodinu();
            if (f != null)
            {
                sprava.PridatOsobuDoRodinyJakoPartnera(sprava.getAktualniOsoba(), f);
            }
            UdelejPoradek();
            this.Refresh();
        }

        private void ToolStripMenuItemUlozitZmenyVRodine_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;

            if (pomFam == null) return;

            pomFam.Marriage = checkBoxOddani.Checked;
            if (pomFam.Marriage)
            {
                pomFam.PresnostSvatby = !checkBoxOddaniPriblizne.Checked;
                pomFam.MarriageDate = textBoxDatumOddani.Text;
                //textBoxSvedci.Text;
                pomFam.Svedci = textBoxSvedci.Text;
            }
            //neco zapomel jsem co
            //--
            pomFam.Div = checkBoxRozvedeni.Checked;
            if (pomFam.Div)
            {
                pomFam.PresnostRozvodu = !checkBoxPriblizneRozvedeni.Checked;
                pomFam.DivDate = textBoxDatumRozvodu.Text;
            }
            sprava.ZmenRodinu(pomFam);
            /*foreach (Individual ch in pomFam.Children)
            {
                NastavListViewItem(listViewVlastniDeti, ch.Id.ToString(), ch.dejCelePrijmeniJmenoNarozeni(), ch);
            }*/
        }

        private void textBoxDatumKrestu_Validated(object sender, EventArgs e)
        {
            ValidujDatum(textBoxDatumKrestu.Text);
        }

        private void ToolStripMenuItemPridatPartnera_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;

            if (pomFam == null) return;

            if (pomFam.WifeId != null && pomFam.HusbandId != null)
            {
                MessageBox.Show("Již jsou přiděleni oba partneři!");
                return;
            }

            VyberOsoby vo = new VyberOsoby("Vyberte partnera/ku.", sprava.getOsobyListBoxItem(1), null);

            if (vo.ShowDialog() == DialogResult.OK)
            {
                if (vo.VybranaOsoba == null || vo.VybranaOsoba == sprava.getAktualniOsoba())
                {
                    MessageBox.Show("Tato osoba již v této rodině je jako partner!");
                    return;
                }
                sprava.PridatOsobuDoRodinyJakoPartnera(vo.VybranaOsoba, pomFam);
                ToolStripMenuItemUlozitZmenyVRodine_Click(sender, e);
            }
        }

        private void ToolStripMenuItemOdebratRodinuZRodokmenu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;

            if (pomFam == null) return;

            sprava.OdeberRodinuZRodokmenu(pomFam);

            //VynulujVse();
            UdelejPoradek();
            this.NaplnPoleOsoby(sprava.getAktualniOsoba());
        }

        private void ToolStripMenuItemOdebratZRodiny_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;

            if (pomFam == null) return;

            sprava.OdeberOsobuZRodiny(sprava.getAktualniOsoba(), pomFam);

        }

        private void ToolStripMenuItemZmenitPartnera_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;

            if (pomFam == null) return;

            VyberOsoby vo = new VyberOsoby("Vyberte partnera/ku.", sprava.getOsobyListBoxItem(1), null);

            if (vo.ShowDialog() == DialogResult.OK)
            {
                if (vo.VybranaOsoba == null || vo.VybranaOsoba == sprava.getAktualniOsoba())
                {
                    MessageBox.Show("Tato osoba již v této rodině je jako partner!");
                    return;
                }
                sprava.ZmenitPartneryVRodineJakoPartnera(vo.VybranaOsoba, sprava.getAktualniOsoba(), pomFam);
                ToolStripMenuItemUlozitZmenyVRodine_Click(sender, e);
            }
        }

        private void buttonVyberNaOtce_Click(object sender, EventArgs e)
        {
            ZmenaPartneraMetodaNaPripravu(sender, e, true);
        }

        private void ZmenaPartneraMetodaNaPripravu(object sender, EventArgs e, bool muz)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            /*if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;*/
            Family pomFam = null;
            //bool vytvorenaNova = false;
            if (sprava.getAktualniOsoba().ParentFamilyId != null
                && sprava.getAktualniOsoba().ParentFamilyId.Count > 0)
            {
                pomFam = sprava.getAktualniOsoba().ParentFamilyId[0];
            }
            /*else
            {
                pomFam = sprava.VytvorNovouRodinu();
                vytvorenaNova = true;
            }*/

            //if (pomFam == null) return;

            string hlaska = "Vyberte ";

            if (muz)
            {
                hlaska += "otce!";
            }
            else
            {
                hlaska += "matku!";
            }
            VyberOsoby vo = new VyberOsoby(hlaska, sprava.getOsobyListBoxItem(1), null);


            if (vo.ShowDialog() == DialogResult.OK)
            {
                if (vo.VybranaOsoba == null || vo.VybranaOsoba == sprava.getAktualniOsoba())
                {
                    MessageBox.Show("Tato osoba již v této rodině je jako dítě!");
                    /*if (vytvorenaNova)
                    {
                        toolStripMenuItemZpet_Click(sender, e);
                    }*/
                    return;
                }
                sprava.ZmenitPartneryVRodineJakoPartneraSDitem(vo.VybranaOsoba, sprava.getAktualniOsoba(), pomFam, muz);
                ToolStripMenuItemUlozitOsobu_Click(sender, e);
            }
            /*else
            {
                if (vytvorenaNova)
                {
                    toolStripMenuItemZpet_Click(sender, e);
                }
            }*/
        }

        private void buttonVyberNaMatku_Click(object sender, EventArgs e)
        {
            ZmenaPartneraMetodaNaPripravu(sender, e, false);
        }

        private void ToolStripMenuItemPridatDite_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;

            if (pomFam == null) return;

            VyberOsoby vo = new VyberOsoby("Vyberte dítě", sprava.getOsobyListBoxItem(1), null);

            if (vo.ShowDialog() == DialogResult.OK)
            {
                if (vo.VybranaOsoba == null || vo.VybranaOsoba == sprava.getAktualniOsoba()
                    //|| vo.VybranaOsoba.ParentFamilyId.Contains(pomFam)
                    )
                {
                    MessageBox.Show("Tato osoba již v této rodině je jako partner!");
                    return;
                }
                sprava.ZmenitVRodineJakoDite(vo.VybranaOsoba, pomFam);
                ToolStripMenuItemUlozitZmenyVRodine_Click(sender, e);
            }
        }

        private void ToolStripMenuItemOdebratDite_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewPartneriARodiny.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybranou rodinu!");
                return;
            }
            if (listViewVlastniDeti.SelectedIndices.Count < 1)
            {
                MessageBox.Show("Nemáte vybrané dítě!");
                return;
            }
            Family pomFam = (Family)listViewPartneriARodiny.SelectedItems[0].Tag;
            Individual dite = (Individual)listViewVlastniDeti.SelectedItems[0].Tag;
            if (pomFam == null) return;

            sprava.OdeberOsobuZRodiny(dite, pomFam);

        }

        private void checkBoxOddaniPriblizne_Validated(object sender, EventArgs e)
        {
            checkBoxOddani.Checked = true;
        }

        private void textBoxDatumOddani_TextChanged(object sender, EventArgs e)
        {
            checkBoxOddani.Checked = true;
        }

        private void comboBox1MistoSvatby_SelectedIndexChanged(object sender, EventArgs e)
        {
            checkBoxOddani.Checked = true;
        }

        private void textBoxSvedci_TextChanged(object sender, EventArgs e)
        {
            checkBoxOddani.Checked = true;
        }

        private void checkBoxPriblizneRozvedeni_CheckedChanged(object sender, EventArgs e)
        {
            checkBoxRozvedeni.Checked = true;
        }

        private void toolStripMenuItemZpet_Click(object sender, EventArgs e)
        {
            sprava.NastavRodokmenPrezZmenou();
            UdelejPoradek();
            this.Refresh();
        }

        private void toolStripMenuItemZnovu_Click(object sender, EventArgs e)
        {
            sprava.NastavRodokmenPoZmene();
            UdelejPoradek();
            this.Refresh();
        }

        private void NastavTamAZpet()
        {

            if (sprava.IsAktualniRodokmen())
            {
                if (sprava.SpravceHist.isPrvniAktualni()
                    && sprava.SpravceHist.isPosledniAktualni())//jen jeden tedy nic 
                {
                    toolStripMenuItemZpet.Enabled = false;
                    toolStripMenuItemZnovu.Enabled = false;
                }
                else if (sprava.SpravceHist.isPrvniAktualni()
                   && !sprava.SpravceHist.isPosledniAktualni())//pouze znovu
                {
                    toolStripMenuItemZpet.Enabled = false;
                    toolStripMenuItemZnovu.Enabled = true;
                }
                else if (!sprava.SpravceHist.isPrvniAktualni()
                   && sprava.SpravceHist.isPosledniAktualni())//pouze zpet
                {
                    toolStripMenuItemZpet.Enabled = true;
                    toolStripMenuItemZnovu.Enabled = false;
                }
                else if (!sprava.SpravceHist.isPrvniAktualni()
                  && !sprava.SpravceHist.isPosledniAktualni())//znovu i zpet
                {
                    toolStripMenuItemZpet.Enabled = true;
                    toolStripMenuItemZnovu.Enabled = true;
                }
                else
                {//prevence
                    toolStripMenuItemZpet.Enabled = false;
                    toolStripMenuItemZnovu.Enabled = false;
                }
            }
            else
            {
                toolStripMenuItemZpet.Enabled = false;
                toolStripMenuItemZnovu.Enabled = false;
            }
        }

        private void buttonDoRodinyDite_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            /*if (sprava.getAktualniOsoba().ParentFamilyId == null
                || sprava.getAktualniOsoba().ParentFamilyId.Count<1)
            {
                MessageBox.Show("Osoba musí mít definovaného alespoň jednoho rodiče!");
                return;
            }*/
            Family pomFam = null;
            VyberRodiny vr = new VyberRodiny("Vyberte rodinu!",
                sprava.getRodinyVsechnyListBoxItem(),
                null);
            if (vr.ShowDialog() == DialogResult.OK)
            {
                pomFam = vr.VybranaRodina;

                /*sprava.PridatDoRodinySourozence(sprava.getAktualniOsoba(), vo.VybranaOsoba, pomFam);
                ToolStripMenuItemUlozitOsobu_Click(sender, e);*/

                sprava.ZmenitVRodineJakoDite(sprava.getAktualniOsoba(), pomFam);
                ToolStripMenuItemUlozitOsobu_Click(sender, e);
            }
        }

        private void buttonPridatSourozence_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (sprava.getAktualniOsoba().ParentFamilyId == null
                || sprava.getAktualniOsoba().ParentFamilyId.Count < 1)
            {
                MessageBox.Show("Osoba musí mít definovaného alespoň jednoho rodiče!");
                return;
            }
            Family pomFam = null;
            VyberRodiny vr = new VyberRodiny("Vyberte rodinu!",
                sprava.getRodinyListBoxItem(sprava.getAktualniOsoba()),
                null);
            if (vr.ShowDialog() == DialogResult.OK)
            {
                pomFam = vr.VybranaRodina;
                VyberOsoby vo = new VyberOsoby("Vyberte sourozence!", sprava.getOsobyListBoxItem(1), null);
                if (vo.ShowDialog() == DialogResult.OK)
                {
                    if (vo.VybranaOsoba == null || vo.VybranaOsoba == sprava.getAktualniOsoba())
                    {
                        MessageBox.Show("Tato osoba již v této rodině je jako dítě!");
                        return;
                    }
                    /*if (pomFam == null) //toto zatim netvořím
                    {

                    }*/
                    sprava.PridatDoRodinySourozence(sprava.getAktualniOsoba(), vo.VybranaOsoba, pomFam);
                    ToolStripMenuItemUlozitOsobu_Click(sender, e);
                }
            }
        }

        private void buttonDiteZRodiny_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (sprava.getAktualniOsoba().ParentFamilyId == null
                || sprava.getAktualniOsoba().ParentFamilyId.Count < 1)
            {
                MessageBox.Show("Osoba musí mít definovaného alespoň jednoho rodiče!");
                return;
            }
            sprava.UlozVerziRodokmenu();
            sprava.OdeberOsobuZRodiny(sprava.getAktualniOsoba(), sprava.getAktualniOsoba().ParentFamilyId[0]);
            ToolStripMenuItemUlozitOsobu_Click(sender, e);
        }

        private void ToolStripMenuItemMistaVybraneOsobyRucne_Click(object sender, EventArgs e)
        {
            this.Refresh();
            MapForm mf = new MapForm("Místa vybrané osoby", sprava.dejMistaPlaceVybraneOsoby(), true);
            mf.ShowDialog();
        }

        private void comboBoxMistoPohrbeni_Validated(object sender, EventArgs e)
        {
            comboBoxUmrti.SelectedIndex = 2;
        }

        private void comboBoxPricina_Validated(object sender, EventArgs e)
        {
            comboBoxUmrti.SelectedIndex = 2;
        }

        private void listViewDokumentSeznam_SelectedIndexChanged(object sender, EventArgs e)
        {
            //VynulujDokumenty();
            ObjFile pomO = null;
            if (listViewDokumentSeznam.SelectedIndices.Count > 0)
            {
                pomO = ((ObjFile)listViewDokumentSeznam.SelectedItems[0].Tag);
            }

            if (pomO == null) return;

            if (pomO.Title != null) textBoxDokumentNazev.Text = pomO.Title;
            if (pomO.Path != null)
            {
                textBoxDokumentCesta.Text = pomO.Path;
                if (File.Exists(pomO.Path))
                {
                    labelDokumentNalezen.Text = "Soubor existuje";
                }
                else
                {
                    labelDokumentNalezen.Text = "Soubor nenalezen";
                }
            }
            else
            {
                labelDokumentNalezen.Text = "Soubor nenalezen";
            }
            if (pomO.Form != null) labelDokumentTyp.Text = pomO.Form;
            checkBoxDokumentPortret.Checked = pomO.Prim;

            if (pomO.Type != null)
            {
                if (pomO.Type.ToUpper().Equals("DOC"))
                {
                    comboBoxDokumentKategorie.SelectedIndex = 1;
                }
                else if (pomO.Type.ToUpper().Equals("PHOTO"))
                {
                    comboBoxDokumentKategorie.SelectedIndex = 2;
                }
                else if (pomO.Type.ToUpper().Equals("BOOK"))
                {
                    comboBoxDokumentKategorie.SelectedIndex = 3;
                }
                else
                {
                    comboBoxDokumentKategorie.SelectedIndex = 0;
                }
            }
            else
            {
                comboBoxDokumentKategorie.SelectedIndex = 0;
            }

        }

        private void buttonDokumentNovy_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            sprava.VytvorNovyDokument(0);

            AktualizujVseNaOsobe(sender, e);
        }

        private void AktualizujVseNaOsobe(object sender, EventArgs e)
        {
            listViewSeznamOsob_SelectedIndexChanged(sender, e);
            //ToolStripMenuItemUlozitOsobu_Click(sender, e);
        }

        private void buttonDokumentSmazat_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewDokumentSeznam.SelectedIndices.Count == 0)
            {
                MessageBox.Show("Nemáte vybrándokument!");
                return;
            }

            sprava.SmazDokumentNaAktualniOsobe((ObjFile)listViewDokumentSeznam.SelectedItems[0].Tag);

            AktualizujVseNaOsobe(sender, e);
        }

        private void buttonDokumentUlozit_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewDokumentSeznam.SelectedIndices.Count == 0)
            {
                MessageBox.Show("Nemáte vybrándokument!");
                return;
            }
            UlozitDokument();

            AktualizujVseNaOsobe(sender, e);
        }

        private void UlozitDokument()
        {
            if (!sprava.IsAktualniRodokmen()
                || sprava.getAktualniOsoba() == null
                || listViewDokumentSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewDokumentSeznam.SelectedItems[0].Tag);
            if (pom == null) return;
            pom.Title = textBoxDokumentNazev.Text;
            pom.Path = textBoxDokumentCesta.Text;
            pom.Nalezen = File.Exists(pom.Path);
            if (pom.Path.Contains("."))
            {
                string[] casti = pom.Path.Split('.');
                if (casti.Length > 0)
                {
                    pom.Form = casti[casti.Length - 1];
                }
                else
                {
                    pom.Form = "neznámý";
                }
            }
            else
            {
                pom.Form = "neznámý";
            }

            pom.Prim = checkBoxDokumentPortret.Checked;

            switch (comboBoxDokumentKategorie.SelectedIndex)
            {
                case 1:
                    pom.Type = "DOC";
                    break;
                case 2:
                    pom.Type = "PHOTO";
                    break;
                case 3:
                    pom.Type = "BOOK";
                    break;
                default:
                    pom.Type = "";
                    break;
            }
            string vysledek = sprava.UlozitSoubor(sprava.getAktualniOsoba(), pom, true);
            if (!string.IsNullOrWhiteSpace(vysledek))
            {
                pom.Path = vysledek;
            }
        }

        private void buttonDokumentOtevrit_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen()
                || sprava.getAktualniOsoba() == null
                || listViewDokumentSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewDokumentSeznam.SelectedItems[0].Tag);

            if (pom == null) return;
            if (!File.Exists(pom.Path)) return;

            try
            {
                System.Diagnostics.Process.Start(pom.Path);
            }
            catch (System.ComponentModel.Win32Exception noBrowser)
            {
                if (noBrowser.ErrorCode == -2147467259)
                    MessageBox.Show(noBrowser.Message);
            }
            catch (System.Exception other)
            {
                MessageBox.Show(other.Message);
            }
        }

        private void listViewFotkaSeznam_SelectedIndexChanged(object sender, EventArgs e)
        {
            //VynulujFotky();
            ObjFile pomO = null;
            if (listViewFotkaSeznam.SelectedIndices.Count > 0)
            {
                pomO = ((ObjFile)listViewFotkaSeznam.SelectedItems[0].Tag);
            }

            if (pomO == null) return;

            if (pomO.Title != null) textBoxFotkaNazev.Text = pomO.Title;
            pictureBoxFotkaNahled.Image = null;

            if (pomO.Path != null)
            {
                textBoxFotkaSoubor.Text = pomO.Path;
                if (File.Exists(pomO.Path))
                {
                    labelFotkaNalezena.Text = "Soubor existuje";
                    try
                    {
                        pictureBoxFotkaNahled.Image = Image.FromFile(pomO.Path);
                    }
                    catch
                    {
                        pictureBoxFotkaNahled.Image = null;
                    }
                }
                else
                {
                    labelFotkaNalezena.Text = "Soubor nenalezen";
                }
            }
            else
            {
                labelFotkaNalezena.Text = "Soubor nenalezen";
            }
            if (pomO.Form != null) labelDokumentTyp.Text = pomO.Form;
            checkBoxFotkaPortret.Checked = pomO.Prim;
        }

        private void buttonFotkaZmenitCestu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                return;
            }
            if (listViewFotkaSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewFotkaSeznam.SelectedItems[0].Tag);

            if (pom == null || string.IsNullOrWhiteSpace(pom.Path))
            {

            }
            else
            {

            }
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.CheckFileExists = true;
            ofd.CheckPathExists = true;
            ofd.Title = "Vyberte soubor";

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                //pom.Path = ofd.FileName;
                textBoxFotkaSoubor.Text = ofd.FileName;
            }
        }

        private void buttonDokumentZmenitCestu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                return;
            }
            if (listViewDokumentSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewDokumentSeznam.SelectedItems[0].Tag);

            if (pom == null || string.IsNullOrWhiteSpace(pom.Path))
            {

            }
            else
            {

            }
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.CheckFileExists = true;
            ofd.CheckPathExists = true;
            ofd.Title = "Vyberte soubor";

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                //pom.Path = ofd.FileName;
                textBoxDokumentCesta.Text = ofd.FileName;
            }
        }

        private void buttonFotkaNova_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            sprava.VytvorNovyDokument(2);

            AktualizujVseNaOsobe(sender, e);
        }

        private void buttonFotkaSmazat_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewFotkaSeznam.SelectedIndices.Count == 0)
            {
                MessageBox.Show("Nemáte vybrándokument!");
                return;
            }

            sprava.SmazDokumentNaAktualniOsobe((ObjFile)listViewFotkaSeznam.SelectedItems[0].Tag);

            AktualizujVseNaOsobe(sender, e);
        }

        private void buttonFotkaUlozit_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewFotkaSeznam.SelectedIndices.Count == 0)
            {
                MessageBox.Show("Nemáte vybrándokument!");
                return;
            }
            UlozitFotku();

            AktualizujVseNaOsobe(sender, e);
        }

        private void UlozitFotku()
        {
            if (!sprava.IsAktualniRodokmen()
                || sprava.getAktualniOsoba() == null
                || listViewFotkaSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewFotkaSeznam.SelectedItems[0].Tag);
            if (pom == null) return;
            pom.Title = textBoxFotkaNazev.Text;
            pom.Path = textBoxFotkaSoubor.Text;
            pom.Nalezen = File.Exists(pom.Path);
            if (pom.Path.Contains("."))
            {
                string[] casti = pom.Path.Split('.');
                if (casti.Length > 0)
                {
                    pom.Form = casti[casti.Length - 1];
                }
                else
                {
                    pom.Form = "neznámý";
                }
            }
            else
            {
                pom.Form = "neznámý";
            }

            pom.Prim = checkBoxFotkaPortret.Checked;

            pom.Type = "PHOTO";

            string vysledek = sprava.UlozitSoubor(sprava.getAktualniOsoba(), pom, true);
            if (!string.IsNullOrWhiteSpace(vysledek))
            {
                pom.Path = vysledek;
            }
        }

        private void buttonFotkaOtevrit_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen()
                || sprava.getAktualniOsoba() == null
                || listViewFotkaSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewFotkaSeznam.SelectedItems[0].Tag);

            if (pom == null) return;
            if (!File.Exists(pom.Path)) return;

            try
            {
                System.Diagnostics.Process.Start(pom.Path);
            }
            catch (System.ComponentModel.Win32Exception noBrowser)
            {
                if (noBrowser.ErrorCode == -2147467259)
                    MessageBox.Show(noBrowser.Message);
            }
            catch (System.Exception other)
            {
                MessageBox.Show(other.Message);
            }
        }

        private void listViewMatrikaSeznam_SelectedIndexChanged(object sender, EventArgs e)
        {
            ObjFile pomO = null;
            if (listViewMatrikaSeznam.SelectedIndices.Count > 0)
            {
                pomO = ((ObjFile)listViewMatrikaSeznam.SelectedItems[0].Tag);
            }

            if (pomO == null) return;

            if (pomO.Title != null) textBoxMatrikaNazev.Text = pomO.Title;
            pictureBoxMatrikaNahled.Image = null;

            if (pomO.Path != null)
            {
                textBoxMatrikaSoubor.Text = pomO.Path;
                if (File.Exists(pomO.Path))
                {
                    labelMatrikaSOuborNalezen.Text = "Soubor existuje";
                    try
                    {
                        pictureBoxMatrikaNahled.Image = Image.FromFile(pomO.Path);
                    }
                    catch
                    {
                        pictureBoxMatrikaNahled.Image = null;
                    }
                }
                else
                {
                    labelMatrikaSOuborNalezen.Text = "Soubor nenalezen";
                }
            }
            else
            {
                labelFotkaNalezena.Text = "Soubor nenalezen";
            }
            if (pomO.Form != null) labelMatrikaTyp.Text = pomO.Form;
            checkBoxFotkaPortret.Checked = pomO.Prim;

            textBoxMatrikaZdroj.Text = pomO.Zdroj;
            textBoxMatrikaMistoVeZdroje.Text = pomO.MistoVeZdroji;
            textBoxKoment.Text = pomO.Comment;
        }

        private void buttonMatrikaNova_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            sprava.VytvorNovyDokument(3);

            AktualizujVseNaOsobe(sender, e);
        }

        private void buttonMatrikaSmazat_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewMatrikaSeznam.SelectedIndices.Count == 0)
            {
                MessageBox.Show("Nemáte vybrán dokument!");
                return;
            }

            sprava.SmazDokumentNaAktualniOsobe((ObjFile)listViewMatrikaSeznam.SelectedItems[0].Tag);

            AktualizujVseNaOsobe(sender, e);
        }

        private void buttonMatrikaUlozit_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                MessageBox.Show("Nemáte založen rodokmen!");
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou osobu!");
                return;
            }
            if (listViewMatrikaSeznam.SelectedIndices.Count == 0)
            {
                MessageBox.Show("Nemáte vybrán dokument!");
                return;
            }
            UlozitMatriku();

            AktualizujVseNaOsobe(sender, e);
        }

        private void UlozitMatriku()
        {
            if (!sprava.IsAktualniRodokmen()
                || sprava.getAktualniOsoba() == null
                || listViewMatrikaSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewMatrikaSeznam.SelectedItems[0].Tag);
            if (pom == null) return;
            pom.Title = textBoxMatrikaNazev.Text;
            pom.Path = textBoxMatrikaSoubor.Text;
            pom.Nalezen = File.Exists(pom.Path);
            if (pom.Path.Contains("."))
            {
                string[] casti = pom.Path.Split('.');
                if (casti.Length > 0)
                {
                    pom.Form = casti[casti.Length - 1];
                }
                else
                {
                    pom.Form = "neznámý";
                }
            }
            else
            {
                pom.Form = "neznámý";
            }

            pom.Type = "BOOK";

            pom.Zdroj = textBoxMatrikaZdroj.Text;
            pom.MistoVeZdroji = textBoxMatrikaMistoVeZdroje.Text;
            pom.Comment = textBoxKoment.Text;
            string vysledek = sprava.UlozitSoubor(sprava.getAktualniOsoba(), pom, true);
            if (!string.IsNullOrWhiteSpace(vysledek))
            {
                pom.Path = vysledek;
            }
        }

        private void buttonMatrikaZmenitCestu_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen())
            {
                return;
            }
            if (sprava.getAktualniOsoba() == null)
            {
                return;
            }
            if (listViewMatrikaSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewMatrikaSeznam.SelectedItems[0].Tag);

            if (pom == null || string.IsNullOrWhiteSpace(pom.Path))
            {

            }
            else
            {

            }
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.CheckFileExists = true;
            ofd.CheckPathExists = true;
            ofd.Title = "Vyberte soubor";

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                //pom.Path = ofd.FileName;
                textBoxMatrikaSoubor.Text = ofd.FileName;
            }
        }

        private void buttonMatrikaOtevrit_Click(object sender, EventArgs e)
        {
            if (!sprava.IsAktualniRodokmen()
                || sprava.getAktualniOsoba() == null
                || listViewMatrikaSeznam.SelectedIndices.Count == 0)
            {
                return;
            }
            ObjFile pom = ((ObjFile)listViewMatrikaSeznam.SelectedItems[0].Tag);

            if (pom == null) return;
            if (!File.Exists(pom.Path)) return;

            try
            {
                System.Diagnostics.Process.Start(pom.Path);
            }
            catch (System.ComponentModel.Win32Exception noBrowser)
            {
                if (noBrowser.ErrorCode == -2147467259)
                    MessageBox.Show(noBrowser.Message);
            }
            catch (System.Exception other)
            {
                MessageBox.Show(other.Message);
            }
        }

        private void toolStripMenuItemStromPredkuNahoru_Click(object sender, EventArgs e)
        {
            if (sprava.getAktualniOsoba() == null)
            {
                MessageBox.Show("Nemáte vybranou aktuální osobu!");
                return;
            }
            VizualizaceStromu vs = new VizualizaceStromu(false);
            vs.VychoziOsoba = sprava.getAktualniOsoba();
            vs.Osoby = sprava.DejOsobyDictionary();
            vs.ShowDialog();
        }
    }
}
