﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using RodokmenDiplomka.Forms;

namespace RodokmenDiplomka.Function
{
    public partial class CasovaOsa : Form
    {
        private bool nactiCtverce = true;
        private List<Ctverec> vykresleneZaznamy = new List<Ctverec>();
        private List<Individual> osoby = null;


        List<Brush> barvy = new List<Brush>();
        private Dictionary<int, List<String>> poleZaznamu = new Dictionary<int, List<string>>();
        private int pocetZaznamu = 0;
        private int maxVyskaZaznamu = 0;
        private int minRok = int.MaxValue;
        private int maxRok = int.MinValue;

        public List<Individual> Osoby
        {
            get { return osoby; }
            set
            {
                osoby = value;
                ProberZaznamy();
            }
        } 

        public CasovaOsa()
        {
            barvy.Add(new SolidBrush(Color.Black));
            barvy.Add(new SolidBrush(Color.Green));
            barvy.Add(new SolidBrush(Color.Blue));
            barvy.Add(new SolidBrush(Color.Yellow));
            barvy.Add(new SolidBrush(Color.Violet));
            barvy.Add(new SolidBrush(Color.Red));

            InitializeComponent();

        }

        private void panelMalovani_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen p = new Pen(DejBrush(0));

            g.DrawRectangle(p, 0, 0, panelMalovani.Width - 1, panelMalovani.Height - 1);

            //g.DrawRectangle(p, 80, 0, 20, panelMalovani.Height - 1);

            GraphicsPath path = new GraphicsPath();
            StringFormat drawFormat = new StringFormat();
            drawFormat.Alignment = StringAlignment.Center;

            SolidBrush drawBrush = new SolidBrush(Color.Black);

            int velikostTextu = Math.Min(panelMalovani.Width / 20, panelMalovani.Height / 20);

            if (Osoby == null) return;

            //------------------------------------- nastavit spravny poměr velikosti aby se dalo vše zobrazit
            int pomocnaDelkaPole = Math.Abs(maxRok - minRok + 1);
            int pomocnaVyskaVPoli = maxVyskaZaznamu;

            int vyskaDilku = Math.Max(panelMalovani.Height / (pomocnaVyskaVPoli + 1), 1);
            int sirkaDilku = Math.Max(panelMalovani.Width / (pomocnaDelkaPole + 1), 1);
            int zacatekTextu = vyskaDilku * (pomocnaVyskaVPoli);// +vyskaDilku * 1 / 8;
            Font drawFont = new Font("Arial", Math.Max(Math.Min((vyskaDilku / 3), (sirkaDilku / 3)), 1));
            Font drawFont2 = new Font("Arial", Math.Max(Math.Min((vyskaDilku / 4), (sirkaDilku / 4)), 1));
            int odsazeniVeZbytku = (sirkaDilku * pomocnaDelkaPole + 1) / 2;

            List<int> pomRoky = poleZaznamu.Keys.ToList<int>();


            //--------------------------------------------------------------- casova osa
            /*int minStoleti = (minRok / 100);
            int maxStoleti = (maxRok / 100);
            for (int i = minStoleti; i <= maxStoleti; i++)
            {
                int poceDilku = 0;
                if (i * 100 <= minRok && (i+1) * 100 <= maxRok)
                {
                    poceDilku = maxRok - minRok+1;
                }
                else if (i * 100 < minRok) {
                    poceDilku = minRok - (i * 100);
                }
                else if (i * 100 >= minRok && (i + 1) * 100 <= maxRok)
                {
                    poceDilku = 100;
                }
                else if (i * 100 >= maxRok)
                {
                    poceDilku = maxRok - (i * 100);
                }
                else {
                    
                }
                //zde neco kraslit
            }*/
            //--------------------------------------------------------------- kresleni jednotlivých dílku
            //g.DrawRectangle(p, 0, 0, pomocnaDelkaPole * sirkaDilku - 1, pomocnaVyskaVPoli * vyskaDilku - 1);
            for (int i = 0; i < pomRoky.Count; i++)
            {
                // jeste pak udelat ten text a treba nejblizsi udalost
                int zaklad = pomRoky[i] - minRok;
                //g.DrawString("" + pomRoky[i], drawFont, DejBrush(i), (sirkaDilku * i), zacatekTextu);
                for (int j = 0; j < poleZaznamu[pomRoky[i]].Count; j++)
                {
                    g.FillRectangle(DejBrush(j + i), /*-odsazeniVeZbytku + */(sirkaDilku * zaklad), 0 + (vyskaDilku * j + 1), (sirkaDilku), (vyskaDilku));

                    if (nactiCtverce)
                    {
                        Ctverec ct = new Ctverec();
                        ct.x = (sirkaDilku * zaklad);
                        ct.y = 0 + (vyskaDilku * j + 1);
                        ct.xx = (sirkaDilku * zaklad) + sirkaDilku;
                        ct.yy = 0 + (vyskaDilku * j + 1) + vyskaDilku;
                        ct.hotnota = pomRoky[i];
                        vykresleneZaznamy.Add(ct);
                    }
                }
            }
            nactiCtverce = false;
            //test
            /*for (int i = 0; i < Math.Min(pomocnaDelkaPole, pomocnaVyskaVPoli); i++)
            {
                g.FillRectangle(DejBrush(i), 0 + (sirkaDilku * i + 1), 0 + (vyskaDilku * i + 1), (sirkaDilku), (vyskaDilku));
                g.DrawString("1950", drawFont, DejBrush(i), (sirkaDilku * i), zacatekTextu);
                g.DrawString("19.05.", drawFont2, DejBrush(i), (sirkaDilku * i), zacatekTextu + Math.Min((vyskaDilku / 2), (sirkaDilku / 2)));
                //g.DrawString("Co to bylo", drawFont2, DejPero(i), (sirkaDilku * i), zacatekTextu + 2 * (Math.Min((vyskaDilku / 2), (sirkaDilku / 2))));//to uz je hodne
            }
            */

            //nejblizsi misto pro zobrazeni
            /*
             public double delkaUsecky(double x, double y, double xx, double yy) {
                double delka;
                delka = Math.pow((Math.pow((x - xx), 2) + Math.pow((y - yy), 2)), 0.5);
                return delka;
                }
             */


        }

        private Brush DejBrush(int p)
        {
            if (barvy == null) return new SolidBrush(Color.Black);

            if (barvy.Count > p)
            {
                return barvy[p];
            }
            do
            {
                p -= barvy.Count;

            } while (barvy.Count <= p);
            return barvy[p];
        }

        private void ProberZaznamy()
        {
            poleZaznamu.Clear();
            pocetZaznamu = 0;
            maxVyskaZaznamu = 0;
            minRok = int.MaxValue;
            maxRok = int.MinValue;
            vykresleneZaznamy.Clear();
            nactiCtverce = true;
            foreach (Individual os in Osoby)
            {
                if (!String.IsNullOrWhiteSpace(os.getRokNarozeni()))
                {
                    int pom = Convert.ToInt32(os.getRokNarozeni());
                    PridejZaznam(pom, os.BirthDate + " narozeni " + os.dejCelePrijmeniJmeno());
                }
                if (!String.IsNullOrWhiteSpace(os.DiedDate) && os.DiedDate.Length >= 4)
                {
                    int pom = Convert.ToInt32(os.DiedDate.Substring(os.DiedDate.Length - 4, 4));
                    PridejZaznam(pom, os.DiedDate + " umrti " + os.dejCelePrijmeniJmeno());
                }
            }
        }

        private void PridejZaznam(int rok, string udalostText)
        {
            if (rok < 0) return;
            if (string.IsNullOrWhiteSpace(udalostText)) return;
            minRok = Math.Min(minRok, rok);
            maxRok = Math.Max(maxRok, rok);
            if (poleZaznamu.ContainsKey(rok))
            {
                poleZaznamu[rok].Add(udalostText);
                maxVyskaZaznamu = Math.Max(poleZaznamu[rok].Count, maxVyskaZaznamu);
            }
            else
            {
                pocetZaznamu++;
                List<string> novePole = new List<string>();
                novePole.Add(udalostText);
                poleZaznamu.Add(rok, novePole);
            }
        }

        private void panelMalovani_Paint2(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen p = new Pen(DejBrush(0));

            int velikostTextu = Math.Min(panelMalovani.Width / 20, panelMalovani.Height / 20);

            if (Osoby == null) return;

            //------------------------------------- nastavit spravny poměr velikosti aby se dalo vše zobrazit

            List<int> pomRoky = poleZaznamu.Keys.ToList<int>();


            //--------------------------------------------------------------- casova osa
            int minStoleti = (minRok / 100);
            int maxStoleti = (maxRok / 100);
            int pomocnaDelkaPole = Math.Abs(maxRok - minRok + 1);
            int sirkaDilPanelMalovani = Math.Max(panelMalovani.Width / (pomocnaDelkaPole + 1), 1);

            for (int i = minStoleti; i <= maxStoleti; i++)
            {
                int poceDilku = 0;
                if (i * 100 <= minRok && (i + 1) * 100 >= maxRok)
                {
                    poceDilku = maxRok - minRok + 1;
                }
                else if (i * 100 < minRok)
                {
                    poceDilku = minRok - (i * 100);
                }
                else if (i * 100 >= minRok && (i + 1) * 100 <= maxRok)
                {
                    poceDilku = 100;
                }
                else if (i * 100 <= maxRok)
                {
                    poceDilku = maxRok - (i * 100);
                }
                else
                {
                    continue;
                }
                //zde neco kreslit
                int sirkaDil = panelRozsahPanelu.Width / (maxRok - minRok);

                int odsazeniZLeva = 0;
                if (minRok / 100 == i)
                {
                    odsazeniZLeva = 0;
                }
                else
                {
                    odsazeniZLeva = ((i * 100) - minRok) * sirkaDil;
                }

                Font drawFont = new Font("Arial", 20);
                g.FillRectangle(DejBrush(i), odsazeniZLeva, 1, sirkaDil * poceDilku, panelRozsahPanelu.Height - 1);
                g.DrawString("" + i, drawFont, DejBrush(i + 1), odsazeniZLeva, 1);
            }
        }

        private void CasovaOsa_Resize(object sender, EventArgs e)
        {
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }

        private void panelMalovani_MouseClick(object sender, MouseEventArgs e)
        {
            Ctverec pom = dejVeKteremCtverciSeKliklo(e.X, e.Y);
            listViewUdalostiVRoce.Clear();

            if (pom.hotnota > 0)
            {
                List<string> naVypsani = poleZaznamu[pom.hotnota];
                if (naVypsani == null) return;
                foreach (string item in naVypsani)
                {
                    ListViewItem lvi = new ListViewItem(item);
                    //lvi.SubItems.Add(item);
                    listViewUdalostiVRoce.Items.Add(lvi);
                }
            }
        }

        private Ctverec dejVeKteremCtverciSeKliklo(int x, int y)
        {
            Ctverec ct = new Ctverec();
            if (vykresleneZaznamy == null) return ct;

            for (int i = 0; i < vykresleneZaznamy.Count; i++)
            {
                if (vykresleneZaznamy[i].x <= x
                    && vykresleneZaznamy[i].y <= y
                    && vykresleneZaznamy[i].xx >= x
                    && vykresleneZaznamy[i].yy >= y)
                {
                    return vykresleneZaznamy[i];
                }
            }
            return ct;
        }
    }
}
