﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using RodokmenDiplomka.Function;

namespace RodokmenDiplomka.Forms
{
    public class SpravceHistorie
    {
        private List<Historie> zmeny;
        public string cestaKDocasneSlozce = "tempProgram/";
        private BinExportImport bei = new BinExportImport();
        private Historie aktualniHistorie = null;
        public SpravceHistorie()
        {
            zmeny = new List<Historie>();
            if (!Directory.Exists(cestaKDocasneSlozce))
            {
                Directory.CreateDirectory(cestaKDocasneSlozce);
            }
        }

        /*public SpravceHistorie(String cestaKTemp)
        {
            zmeny = new List<Historie>();
            if (!string.IsNullOrWhiteSpace(cestaKTemp))
            {
                this.cestaKDocasneSlozce = cestaKTemp;
            }
            if (!Directory.Exists(cestaKTemp))
            {
                Directory.CreateDirectory(cestaKTemp);
            }
        }*/
        ~SpravceHistorie()
        {
            if (aktualniHistorie != null && zmeny != null && zmeny.Count > 0) {
                aktualniHistorie = zmeny[0];
                OdebratPoAktualni();
            }
        }
        public bool ulozit(Rodokmen o)
        {
            if (o == null) return false;
            Historie h = new Historie();
            h.CasPorizeni = DateTime.Now;
            h.CestaKSOuboruHistorie = cestaKDocasneSlozce + h.CasPorizeni.Ticks.ToString() + ".bin";
            h.CestaKSouboru = cestaKDocasneSlozce + h.CasPorizeni.Ticks.ToString() + "soubor.bin";
            bei.Serializace<Historie>(h, h.CestaKSOuboruHistorie);
            bei.Serializace<Rodokmen>(o, h.CestaKSouboru);

            OdebratPoAktualni();
            zmeny.Add(h);
            aktualniHistorie = h;
            return true;
        }

        private void OdebratPoAktualni()
        {
            if (aktualniHistorie == null || zmeny == null) return;
            if (!isPosledniAktualni()) {
                int index = zmeny.IndexOf(aktualniHistorie);
                if (index >= 0 && index < zmeny.Count) {
                    for (int i = zmeny.Count-1; i >= index; i--)
                    {
                        Historie h= zmeny[i];
                        bei.OdeberSoubor(h.CestaKSouboru);
                        bei.OdeberSoubor(h.CestaKSOuboruHistorie);
                        zmeny.RemoveAt(i);
                        h = null;
                        aktualniHistorie = null;
                    }
                    if (zmeny.Count > 0) {
                        aktualniHistorie = zmeny.Last();
                    }
                }
            }
        }
        public Rodokmen NactiDalsi()
        {
            if (aktualniHistorie == null) return null;
            if (!isPosledniAktualni())
            {
                int index = zmeny.IndexOf(aktualniHistorie);
                if (zmeny.Count > index + 1)
                {
                    aktualniHistorie = zmeny[index + 1];
                }
            }
            return ((Rodokmen)bei.Deserializace<Rodokmen>(aktualniHistorie.CestaKSouboru));
        }

        public Rodokmen NactiPredchozi()
        {
            if (aktualniHistorie == null) return null;
            if (!isPrvniAktualni())
            {
                int index = zmeny.IndexOf(aktualniHistorie);
                if (0 <= index-1)
                {
                    aktualniHistorie = zmeny[index-1];
                    return ((Rodokmen)bei.Deserializace<Rodokmen>(zmeny[index].CestaKSouboru));
                }
            }
            return ((Rodokmen)bei.Deserializace<Rodokmen>(aktualniHistorie.CestaKSouboru));
        }

        public Rodokmen NactiAktualni()
        {
            if (aktualniHistorie == null) return null;
            return ((Rodokmen)bei.Deserializace<Rodokmen>(aktualniHistorie.CestaKSouboru));
        }

        public bool isPrvniAktualni()
        {
            if (aktualniHistorie == null || zmeny == null || zmeny.Count < 1) return true;

            if (zmeny[0].Equals(aktualniHistorie))
            {
                return true;
            }
            return false;
        }
        public bool isPosledniAktualni()
        {
            if (aktualniHistorie == null || zmeny == null || zmeny.Count < 1) return true;

            if (zmeny[zmeny.Count - 1].Equals(aktualniHistorie))
            {
                return true;
            }
            return false;
        }
        public bool isUlozenaHistorie()
        {
            if (zmeny == null || zmeny.Count < 1) return false;
            return true;
        }
    }
}
