﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RodokmenDiplomka.Forms;

namespace RodokmenDiplomka.Function
{
    public partial class VizualizaceStromu : Form
    {
        public Dictionary<int, Individual> Osoby { get; set; }
        public Individual VychoziOsoba { get; set; }
        private bool nactiCtverce = true;
        private List<Ctverec> vykresleneZaznamy = new List<Ctverec>();
        List<Brush> barvy = new List<Brush>();
        private Dictionary<int, List<String>> poleZaznamu = new Dictionary<int, List<string>>();
        private int pocetZaznamu = 0;
        int zoom = 1;
        int krajX = 0;
        int krajY = 0;
        Individual oznacenaOsoba = null;
        private bool dolu = true;

        public VizualizaceStromu(bool smer)
        {
            this.dolu = smer;
            barvy.Add(new SolidBrush(Color.Black));
            barvy.Add(new SolidBrush(Color.Green));
            barvy.Add(new SolidBrush(Color.Blue));
            barvy.Add(new SolidBrush(Color.Yellow));
            barvy.Add(new SolidBrush(Color.Violet));
            barvy.Add(new SolidBrush(Color.Red));
            InitializeComponent();
            this.MouseWheel += new MouseEventHandler(panelKresleni_MouseWheel);
        }

        private void panelKresleni_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            g.FillRectangle(new SolidBrush(Color.Coral), 0, 0, panelKresleni.Width, panelKresleni.Height);

            //if (VychoziOsoba == null || Osoby == null) return;
            //pokud neni co vykreslit
            if (VychoziOsoba == null) return;

            Pen p = new Pen(Color.Blue);

            int pocetVyska = Math.Max(1, VychoziOsoba.dejPocetNadurovniRodice());
            int pocetSirka = Math.Max(1, VychoziOsoba.dejSirkuNadurovniRodice());
            //int pocetSirka = rekursivnePrvku(pocetVyska+1);
            int sirkaObd = (panelKresleni.Width / pocetSirka);
            sirkaObd = Math.Max(sirkaObd, 1) * zoom;
            int vyskaObd = (panelKresleni.Height / pocetVyska);
            vyskaObd = Math.Max(vyskaObd, 1) * zoom;
            /*int vyskaObd = panelKresleni.Height / pocetVyska;
            if ((panelKresleni.Height / pocetVyska)*2 > panelKresleni.Width / pocetSirka) {
                vyskaObd = panelKresleni.Width / pocetSirka;
            } 
            vyskaObd = vyskaObd * zoom;*/

            int velikostTextu = Math.Max(1, Math.Min(sirkaObd* zoom, vyskaObd *zoom));
            if (sirkaObd < vyskaObd)
            {
                velikostTextu = Math.Min(Math.Max(velikostTextu / 10, 1),20);
            }
            else
            {
                velikostTextu = Math.Min(Math.Max(velikostTextu / 6, 1),20);
            }
            //velikostTextu = velikostTextu * zoom;
            int startX = 0;// +krajX;
            int startY = 0;// +krajY;
            int poleX = panelKresleni.Width * zoom;
            int poleY = vyskaObd * zoom;

            if (dolu)
            {
                startY = 0;
            }
            else
            {
                startY = (pocetVyska - 1) * vyskaObd;
            }


            /*string text1 = "Use StringFormat and Rectangle objects to center text in a rectangle.";
            using (Font font1 = new Font("Arial", 12, FontStyle.Bold, GraphicsUnit.Point))
            {
                Rectangle rect1 = new Rectangle(10, 10, 100, 100);

                // Create a StringFormat object with the each line of text, and the block 
                // of text centered on the page.
                StringFormat stringFormat = new StringFormat();
                stringFormat.Alignment = StringAlignment.Center;
                stringFormat.LineAlignment = StringAlignment.Center;

                // Draw the text and the surrounding rectangle.
                e.Graphics.DrawString(text1, font1, Brushes.Blue, rect1, stringFormat);
                e.Graphics.DrawRectangle(Pens.Black, rect1);
            }*/

            Namaluj2(g, VychoziOsoba, sirkaObd, vyskaObd, startX, startY, poleX, poleY, velikostTextu, dolu, pocetVyska, new Point());
            nactiCtverce = false;
            /* int urovni = VychoziOsoba.dejPocetNadurovniRodice();
             int velikostVeSmeruX = panelKresleni.Width / (rekursivnePrvku(urovni));
             int velikostVeSmeruY = panelKresleni.Height / (urovni + 1);
             Namaluj(g, urovni, (panelKresleni.Width / 2), 0, velikostVeSmeruX, velikostVeSmeruY, VychoziOsoba,0);*/
        }

        private void Namaluj2(Graphics g, Individual osoba, int sirkaObd, int vyskaObd, int startX, int startY, int poleX, int poleY, int velikostTextu, bool dolu, int uroven, Point bodPredchudce)
        {
            if (osoba == null || osoba.Id < 0) return;

            Point bodAktual;
            if (dolu)
            {
                bodAktual = new Point(krajX + startX + (poleX / 2) - (sirkaObd / 2), krajY + startY + vyskaObd);
            }
            else
            {
                bodAktual = new Point(krajX + startX + (poleX / 2) - (sirkaObd / 2), krajY + startY - vyskaObd);
            }
            if (!bodPredchudce.IsEmpty && !bodAktual.IsEmpty && dolu)
            {
                g.DrawLine(new Pen(Color.Black), bodPredchudce.X+sirkaObd/2, bodPredchudce.Y, bodAktual.X, bodAktual.Y - vyskaObd);
            }
            else if (!bodPredchudce.IsEmpty && !bodAktual.IsEmpty && !dolu)
            {
                g.DrawLine(new Pen(Color.Black), bodPredchudce.X + sirkaObd / 2, bodPredchudce.Y + vyskaObd, bodAktual.X, bodAktual.Y + 2* vyskaObd);
            }
            Rectangle rect1 = new Rectangle(krajX + startX + (poleX / 2  -sirkaObd/2), krajY + startY, sirkaObd, vyskaObd);
            g.FillRectangle(new SolidBrush(Color.GreenYellow), rect1);
            StringFormat stringFormat = new StringFormat();
            stringFormat.Alignment = StringAlignment.Center;
            stringFormat.LineAlignment = StringAlignment.Center;
            g.DrawString(osoba.dejCelePrijmeniJmenoNarozeni(), new Font("Arial", velikostTextu), new SolidBrush(Color.Black), rect1, stringFormat);

            if (nactiCtverce)
            {
                Ctverec ct = new Ctverec();
                ct.x = bodAktual.X;
                if (dolu)
                {
                    ct.y = bodAktual.Y - vyskaObd;
                }
                else
                {
                    ct.y = bodAktual.Y + vyskaObd;
                }
                ct.xx = ct.x + sirkaObd;
                ct.yy = ct.y + vyskaObd;
                ct.hotnota = osoba.Id;
                vykresleneZaznamy.Add(ct);
            }

            int stY = 0;
            if (dolu)
            {
                stY = startY + vyskaObd;
            }
            else
            {
                stY = startY - vyskaObd;
            }

            if (osoba.ParentFamilyId != null && osoba.ParentFamilyId.Count > 0)
            {
                foreach (Family f in osoba.ParentFamilyId)
                {
                    //int pocetVyska = Math.Max(1, f.HusbandId.dejPocetNadurovniRodice());
                    Namaluj2(g, f.HusbandId, sirkaObd, vyskaObd, startX, stY, poleX / 2, poleY, velikostTextu, dolu, uroven--, bodAktual);
                    //int pocetVyska2 = Math.Max(1, f.WifeId.dejPocetNadurovniRodice());
                    Namaluj2(g, f.WifeId, sirkaObd, vyskaObd, startX + (poleX / 2), stY, poleX / 2, poleY, velikostTextu, dolu, uroven--, bodAktual);
                }

            }
        }

        private Brush DejBrush(int p)
        {
            if (barvy == null) return new SolidBrush(Color.Black);

            if (barvy.Count > p)
            {
                return barvy[p];
            }
            do
            {
                p -= barvy.Count;

            } while (barvy.Count <= p);
            return barvy[p];
        }

        private Ctverec dejVeKteremCtverciSeKliklo(int x, int y)
        {
            Ctverec ct = new Ctverec();
            ct.hotnota = -1;
            if (vykresleneZaznamy == null) return ct;

            for (int i = 0; i < vykresleneZaznamy.Count; i++)
            {
                if (vykresleneZaznamy[i].x <= x
                    && vykresleneZaznamy[i].y <= y
                    && vykresleneZaznamy[i].xx >= x
                    && vykresleneZaznamy[i].yy >= y)
                {
                    return vykresleneZaznamy[i];
                }
            }
            return ct;
        }
        private int rekursivnePrvku(int urovni)
        {
            return urovni * 2 + 2 * (urovni - 1);
        }


        private void VizualizaceStromu_Resize(object sender, EventArgs e)
        {
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }

        private void panelKresleni_MouseClick(object sender, MouseEventArgs e)
        {
            Ctverec pom = dejVeKteremCtverciSeKliklo(e.X, e.Y);
            textBoxVypisInformaciOOsobe.Text = "";

            if (pom.hotnota >= 0)
            {
                try
                {
                    if (Osoby == null) return;
                    oznacenaOsoba = Osoby[pom.hotnota];
                    if (oznacenaOsoba == null) return;
                    textBoxVypisInformaciOOsobe.Text = textBoxVypisInformaciOOsobe.Text + " " + oznacenaOsoba.dejCelePrijmeniJmenoNarozeni();
                }
                catch (Exception) { }
            }
        }
        private void panelKresleni_MouseWheel(object sender, MouseEventArgs e)
        {
            int staryZoom = zoom;

            if (e.Delta > 0)
            {
                zoom = Math.Max(1, zoom + 1);
            }
            else if (e.Delta < 0)
            {
                zoom = Math.Max(1, zoom - 1);
            }

            if (zoom == 1)
            {
                krajX = 0;
                krajY = 0;
                nactiCtverce = true;
                vykresleneZaznamy.Clear();
            }
            else
            {
                if (zoom > staryZoom)
                {
                    krajX -= e.X;// -(panelKresleni.Width / 2) * zoom;
                    krajY -= e.Y;// -(panelKresleni.Height / 2) * zoom;
                    nactiCtverce = true;
                    vykresleneZaznamy.Clear();
                }
                else if (zoom < staryZoom)
                {
                    krajX += e.X;// +(panelKresleni.Width / 2) * zoom;
                    krajY += e.Y;// +(panelKresleni.Height / 2) * zoom;
                    nactiCtverce = true;
                    vykresleneZaznamy.Clear();
                }
                // krajX = kra
            }

            this.Refresh();
        }

        private void buttonPepocitej_Click(object sender, EventArgs e)
        {
            if (oznacenaOsoba == null) return;
            VychoziOsoba = oznacenaOsoba;
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            Vynuluj(false);

            this.Refresh();
        }

        private void Vynuluj(bool p)
        {
            zoom = 1;
            krajX = 0;
            krajY = 0;

            if (p)
            {
                oznacenaOsoba = null;
            }
        }

        private void buttonNahoru_Click(object sender, EventArgs e)
        {
            krajY += 20;
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }

        private void buttonDown_Click(object sender, EventArgs e)
        {
            krajY -= 20;
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }

        private void buttonRight_Click(object sender, EventArgs e)
        {
            krajX -= 20;
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }

        private void buttonLeft_Click(object sender, EventArgs e)
        {
            krajX += 20;
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }

        private void buttonZoomPlus_Click(object sender, EventArgs e)
        {
            zoom++;
            krajX = (krajX + 1) * zoom;//+(panelKresleni.Width/(2));
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }

        private void buttonZoomMinus_Click(object sender, EventArgs e)
        {
            zoom--;
            krajX = (krajX + 1) * zoom;
            if (zoom < 1)
            {
                zoom = 1;
                krajX = 0;
                krajY = 0;
            }
            nactiCtverce = true;
            vykresleneZaznamy.Clear();
            this.Refresh();
        }
    }
}
