﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RodokmenDiplomka.Data;

namespace RodokmenDiplomka.Forms
{
    public partial class VyberMista : Form
    {

        public List<ListViewItem> Mista { get; set; }
        public string Otazka { get; set; }
        public Place VybraneMisto { get; set; }
        public String NovyHledanyText { get; set; }
        private bool vynulovanText = false;
        public VyberMista()
        {
            Mista = new List<ListViewItem>();
            Otazka = "";
            VybraneMisto = null;
            InitializeComponent();
            NovyHledanyText = "";
            NastavZobrazeni();
        }

        public VyberMista(string otazka, List<ListViewItem> osoby, Place vybraneMisto)
        {
            if (osoby == null)
            {
                Mista = new List<ListViewItem>();
            }
            else
            {
                Mista = osoby;
            }
            Otazka = otazka;

            VybraneMisto = vybraneMisto;

            InitializeComponent();

            NastavZobrazeni();
        }

        private void NastavZobrazeni()
        {
            if (Otazka == null)
            {
                labelOtazka.Text = "";
            }
            else
            {
                labelOtazka.Text = Otazka;
            }
            listViewOsoby.Items.Clear();
            int index = -1;
            foreach (ListViewItem item in Mista)
            {
                listViewOsoby.Items.Add(item);
                if (VybraneMisto != null && item.Tag == VybraneMisto)
                {
                    index = listViewOsoby.Items.Count - 1;
                }
            }
            if (index >= 0)
            {
                listViewOsoby.SelectedIndices.Clear();
                listViewOsoby.SelectedIndices.Add(index);
            }
        }

        private void listViewOsoby_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listViewOsoby.SelectedIndices.Count > 0)
            {
                VybraneMisto = (Place)listViewOsoby.SelectedItems[0].Tag;
                buttonOk.Enabled = true;
            }
            else
            {
                buttonOk.Enabled = false;
            }
        }

        private void textBoxTextProHledani_MouseClick(object sender, MouseEventArgs e)
        {
            if (!vynulovanText)
            {
                textBoxTextProHledani.Text = "";
                vynulovanText = true;
            }
        }

        private void textBoxTextProHledani_Validated(object sender, EventArgs e)
        {
            if(string.IsNullOrWhiteSpace(textBoxTextProHledani.Text)){
                buttonHledat.Enabled = false;
            }
            else{
                buttonHledat.Enabled = true;
            }
        }

        private void textBoxTextProHledani_TextChanged(object sender, EventArgs e)
        {
            NovyHledanyText = textBoxTextProHledani.Text;
            textBoxTextProHledani_Validated(sender, e);
        }
    }
}
