﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RodokmenDiplomka.Forms
{
    public partial class VyberOsoby : Form
    {

        public List<ListViewItem> Osoby { get; set; }
        public string Otazka { get; set; }
        public Individual VybranaOsoba { get; set; }
        public VyberOsoby()
        {
            Osoby = new List<ListViewItem>();
            Otazka = "";
            VybranaOsoba = null;
            InitializeComponent();

            NastavZobrazeni();
        }

        public VyberOsoby(string otazka, List<ListViewItem> osoby, Individual vybranaOsoba)
        {
            if (osoby == null)
            {
                Osoby = new List<ListViewItem>();
            }
            else
            {
                Osoby = osoby;
            }
            Otazka = otazka;

            VybranaOsoba = vybranaOsoba;

            InitializeComponent();

            NastavZobrazeni();
        }

        private void NastavZobrazeni()
        {
            if (Otazka == null)
            {
                labelOtazka.Text = "";
            }
            else
            {
                labelOtazka.Text = Otazka;
            }
            listViewOsoby.Items.Clear();
            int index = -1;
            foreach (ListViewItem item in Osoby)
            {
                listViewOsoby.Items.Add(item);
                if (VybranaOsoba != null && item.Tag == VybranaOsoba)
                {
                    index = listViewOsoby.Items.Count - 1;
                }
            }
            if (index >= 0)
            {
                listViewOsoby.SelectedIndices.Clear();
                listViewOsoby.SelectedIndices.Add(index);
            }
        }

        private void listViewOsoby_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listViewOsoby.SelectedIndices.Count > 0)
            {
                VybranaOsoba = (Individual)listViewOsoby.SelectedItems[0].Tag;
                buttonOk.Enabled = true;
            }
            else
            {
                buttonOk.Enabled = false;
            }
        }
    }
}
