﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RodokmenDiplomka.Forms
{
    public partial class VyberRodiny : Form
    {

        public List<ListViewItem> Rodiny { get; set; }
        public string Otazka { get; set; }
        public Family VybranaRodina { get; set; }
        public VyberRodiny()
        {
            Rodiny = new List<ListViewItem>();
            Otazka = "";
            VybranaRodina = null;
            InitializeComponent();
            NastavZobrazeni();
        }

        public VyberRodiny(string otazka, List<ListViewItem> rodiny, Family vybranaOsoba)
        {
            if (rodiny == null)
            {
                Rodiny = new List<ListViewItem>();
            }
            else
            {
                Rodiny = rodiny;
            }
            Otazka = otazka;

            VybranaRodina = vybranaOsoba;

            InitializeComponent();

            NastavZobrazeni();
        }

        private void NastavZobrazeni()
        {
            if (Otazka == null)
            {
                labelOtazka.Text = "";
            }
            else
            {
                labelOtazka.Text = Otazka;
            }
            listViewRodiny.Items.Clear();
            int index = -1;
            foreach (ListViewItem item in Rodiny)
            {
                listViewRodiny.Items.Add(item);
                if (VybranaRodina != null && item.Tag == VybranaRodina)
                {
                    index = listViewRodiny.Items.Count - 1;
                }
            }
            if (index >= 0)
            {
                listViewRodiny.SelectedIndices.Clear();
                listViewRodiny.SelectedIndices.Add(index);
            }
        }

        private void listViewOsoby_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listViewRodiny.SelectedIndices.Count > 0)
            {
                VybranaRodina = (Family)listViewRodiny.SelectedItems[0].Tag;
                buttonOk.Enabled = true;
            }
            else
            {
                buttonOk.Enabled = false;
            }
        }
    }
}
