﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace RodokmenDiplomka.Function
{
    public class BinExportImport
    {
        public void Serializace<T>(T o, String path)
        {
            if (o == null || String.IsNullOrWhiteSpace(path)) return;
            //DateTime lDate = new DateTime(1984, 2, 9);
            Stream lStream = new FileStream(path, FileMode.OpenOrCreate);
            IFormatter lFormatter = new BinaryFormatter();
            try
            {
                lFormatter.Serialize(lStream, o);
            }
            finally
            {
                lStream.Close();
            }

        }
        public T Deserializace<T>(String path)
        {
            T oImp = default(T);
            if (String.IsNullOrWhiteSpace(path)) return oImp;
            if (!File.Exists(path)) return oImp;
            IFormatter lFormatter = new BinaryFormatter();
            Stream lStream = new FileStream(path, FileMode.Open);
            try
            {
                oImp = (T)lFormatter.Deserialize(lStream);
            }
            finally
            {
                lStream.Close();
            }
            return oImp;
        }
        public bool OdeberSoubor(string path) {
            if (string.IsNullOrWhiteSpace(path)) return false;
            if (!File.Exists(path)) return false;
            File.Delete(path);
            return true;
        }
    }
}
