﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Maps.MapControl.WPF;
using RodokmenDiplomka.Data;
using RodokmenDiplomka.Map;
using System.Globalization;
using RodokmenDiplomka.Forms;
using RodokmenDiplomka.Function;
using System.IO;

namespace RodokmenDiplomka
{
    public partial class MapForm : Form
    {
        private List<Place> ulozeneBodyMapy;// = new List<Place>();
        static string KEY = "Ai0MQQDswtfC4tN2gm0pq-HWpFKxLyTxrUKpcVW4Kfrb9j-GnRj0QPduzjhKddrP";
        private string cestaKDocasneSlozce = "tempMaps/";
        private bool rucne = false;
        private bool zpet = false;

        public MapForm(String hlavicka, List<Place> body, bool rucne)
        {
            if (!Directory.Exists(cestaKDocasneSlozce))
            {
                Directory.CreateDirectory(cestaKDocasneSlozce);
            }
            this.rucne = rucne;
            var t = new System.Threading.Thread(() => Application.Run(new WaitLog()));
            t.SetApartmentState(System.Threading.ApartmentState.STA);
            t.Start();
            BinExportImport bEI = new BinExportImport();
            ulozeneBodyMapy = bEI.Deserializace<List<Place>>(cestaKDocasneSlozce + "nast_NactenaMista.bin");
            if (ulozeneBodyMapy == null) ulozeneBodyMapy = new List<Place>();
            //kontrola bodu
            InitializeComponent();
            t.Abort();

            this.Text = hlavicka;
            if (body != null)
            {
                int pocetBezSouradnic = 0;

                for (int i = 0; i < body.Count; i++)
                //foreach (Place pl in body)
                {
                    if (body[i].Longtitude == Double.MinValue && body[i].Latitude == Double.MinValue)
                    {
                        foreach (Place ulozenyPl in ulozeneBodyMapy)
                        {

                            if (ulozenyPl != null && ulozenyPl.CelyNazev != null && body[i].CelyNazev.Trim().Equals(ulozenyPl.CelyNazev.Trim()))
                            {
                                //pl.Longtitude = ulozenyPl.Longtitude;
                                //pl.Latitude = ulozenyPl.Latitude;
                                body[i] = ulozenyPl;
                                break;
                            }
                        }
                        pocetBezSouradnic++;
                    }
                }
                if (rucne)
                {
                    pocetBezSouradnic = body.Count;
                }
                DialogProgressBar dpb = new DialogProgressBar("Stahují / hledají se souřadnice k místům", pocetBezSouradnic);
                dpb.Show();
                foreach (Place pl in body)
                {
                    if (pl.Longtitude == Double.MinValue && pl.Latitude == Double.MinValue || rucne)
                    {
                        Place pom = najdiSirkuADelku(pl);
                        if (pom != null)
                        {
                            pl.Latitude = pom.Latitude;
                            pl.Longtitude = pom.Longtitude;
                            if (ulozeneBodyMapy.Contains(pl))
                            {
                                pl.Latitude = pom.Latitude;
                                pl.Longtitude = pom.Longtitude;
                            }
                            else {
                                ulozeneBodyMapy.Add(pl);
                            }
                        }
                        dpb.inkrementuj();
                        if (zpet)
                        {
                            //zpet = false;//kdyz to je modalne tak nemusime resit nulovani hodnoty..
                            //proste dalsi okno zapne
                            break;
                        }
                    }

                }
                dpb.Close();
                int zobrazenoBodu = 0;
                foreach (Place pl in body)
                {
                    if (pl.Longtitude == double.MinValue && pl.Latitude == double.MinValue) continue;

                    Pushpin pp = new Pushpin();
                    pp.Location = new Location(pl.Latitude, pl.Longtitude);
                    pp.Content = pl.CelyNazev;
                    pp.DataContext = pl.CelyNazev;
                    pp.Tag = pl;
                    //pp.in

                    myMapControl1.Map.Children.Add(pp);
                    zobrazenoBodu++;
                }
                if (zobrazenoBodu != body.Count)
                {

                }
                bEI.Serializace<List<Place>>(ulozeneBodyMapy, cestaKDocasneSlozce + "nast_NactenaMista.bin");
            }



        }

        private Place najdiSirkuADelku(Place pl)
        {
            if (String.IsNullOrEmpty(pl.CelyNazev)) return null;

            try
            {

                ServiceReferenceBingMaps.GeocodeRequest geocodeRequest = new ServiceReferenceBingMaps.GeocodeRequest();
                // Set the credentials using a valid Bing Maps Key
                geocodeRequest.Culture = "cs-CZ";
                geocodeRequest.Credentials = new Credentials();
                geocodeRequest.Credentials.ApplicationId = KEY;
                // Set the full address query
                geocodeRequest.Query = pl.CelyNazev;
                // Set the options to only return high confidence results
                ServiceReferenceBingMaps.ConfidenceFilter[] filters = new ServiceReferenceBingMaps.ConfidenceFilter[1];
                filters[0] = new ServiceReferenceBingMaps.ConfidenceFilter();
                filters[0].MinimumConfidence = ServiceReferenceBingMaps.Confidence.Low;
                //add the filters to options
                ServiceReferenceBingMaps.GeocodeOptions geocodeOptions = new ServiceReferenceBingMaps.GeocodeOptions();
                geocodeOptions.Filters = filters;
                geocodeRequest.Options = geocodeOptions;

                // Make the geocode request
                ServiceReferenceBingMaps.GeocodeServiceClient geocodeService =
                new ServiceReferenceBingMaps.GeocodeServiceClient("BasicHttpBinding_IGeocodeService");
                ServiceReferenceBingMaps.GeocodeResponse geocodeResponse = geocodeService.Geocode(geocodeRequest);
                List<Place> moznaMista = new List<Place>();
                if (geocodeResponse.Results != null && geocodeResponse.Results.Length > 0)
                {
                    //List<ServiceReferenceBingMaps.GeocodeResult> mista = geocodeResponse.Results.ToList<ServiceReferenceBingMaps.GeocodeResult>();
                    for (int i = 0; i < geocodeResponse.Results.Length; i++)
                    {
                        //Results = geocodeResponse.Results[i].DisplayName;
                        /*Results = String.Format("Latitude: {0} \nLongitude: {1}",
                            geocodeResponse.Results[i].Locations[0].Latitude,
                            geocodeResponse.Results[i].Locations[0].Longitude);
                        */
                        if (!rucne)
                        {
                            pl.Latitude = geocodeResponse.Results[0].Locations[0].Latitude;
                            pl.Longtitude = geocodeResponse.Results[0].Locations[0].Longitude;
                            return pl;
                        }
                        else
                        {
                            Place pomPl = new Place(geocodeResponse.Results[i].DisplayName + " "
                                + geocodeResponse.Results[i].Locations + " "
                                + geocodeResponse.Results[i].Address.AddressLine + " "
                                + geocodeResponse.Results[i].Address.CountryRegion+ " " 
                                + geocodeResponse.Results[i].Address.Locality);
                            pomPl.Latitude = geocodeResponse.Results[i].Locations[0].Latitude;
                            pomPl.Longtitude = geocodeResponse.Results[i].Locations[0].Longitude;
                            moznaMista.Add(pomPl);
                        }
                        //Location pinLoc = myMapControl1.Map.ViewportPointToLocation(new System.Windows.Point(0, 0));
                        /*Pushpin pp = new Pushpin();
                        pp.Location = new Location(geocodeResponse.Results[i].Locations[0].Latitude, geocodeResponse.Results[i].Locations[0].Longitude);
                        myMapControl1.Map.Children.Add(pp);*/
                    }
                    //dotaz s výběrem
                    if (moznaMista == null || moznaMista.Count <= 0) return null;
                    /*if (moznaMista.Count == 1)//pokud jen jedna vrácená možnost
                    {
                        pl.Latitude = moznaMista[0].Latitude;
                        pl.Longtitude = moznaMista[0].Longtitude;
                        return pl;
                    }*/
                    VyberMista vm = new VyberMista("Vyberte nejvodnější nalezené místo pro: " + pl.CelyNazev, DejMistaListItem(moznaMista), null);
                    DialogResult vobla = vm.ShowDialog();
                    if (vobla == DialogResult.OK)
                    {
                        if (vm.VybraneMisto == null)
                        {
                            return null;
                        }
                        else
                        {
                            pl.Latitude = vm.VybraneMisto.Latitude;
                            pl.Longtitude = vm.VybraneMisto.Longtitude;
                            return pl;
                        }
                    }
                    else if (vobla == DialogResult.Cancel)
                    {
                        zpet = true;
                        return null;
                    }
                    else if(vobla==DialogResult.Retry){
                        if(!string.IsNullOrWhiteSpace(vm.NovyHledanyText)){
                            Place pom = new Place(vm.NovyHledanyText);
                            return najdiSirkuADelku(pom);
                        }
                        return null;
                    }
                    else {
                        return null;
                    }
                }

            }
            catch (Exception eMap)
            {
                MessageBox.Show("Chyby při stahování souřadnic! : " + eMap.Message);
                zpet = true;
            }
            return null;
        }

        private List<ListViewItem> DejMistaListItem(List<Place> moznaMista)
        {
            List<System.Windows.Forms.ListViewItem> seznam = new List<System.Windows.Forms.ListViewItem>();
            List<Family> rodinyRodicuDitete = new List<Family>();
            if (moznaMista == null || moznaMista.Count == 0) return seznam;
            int index = 0;
            foreach (Place p in moznaMista)
            {
                System.Windows.Forms.ListViewItem item = new System.Windows.Forms.ListViewItem(index.ToString());
                String popis = p.CelyNazev + " (" + p.Latitude + "," + p.Longtitude + ")";
                item.SubItems.Add(popis);
                item.Tag = p;
                seznam.Add(item);
                index++;
            }
            return seznam;
        }
    }
}
